<?php

// future plans - give other plugins the ability to add items to the list

class Admin extends Plugin {
  private $openwindows;
  private $buttons;

  function __construct()
  	{
	Plugin::__construct();
	$buttons = array();
  	}  //  __construct

  function showAdmin($command) {
    if ($this->existsPlayerData($command['author'], 'window')) {
      $window = $this->getPlayerData($command['author'], 'window');
      $window->maximize();
    } else {
      $window = $this->createWindowToPlayerFramework('Admin Panel', 1.0, 1.0, $command['author']);

	  $content = '<line>
      <cell><text>$000These are the quick admin commands, just click to execute:</text></cell>
      </line>';
		$ctr = 1;
		foreach($this->buttons as $button) {
			$content .= '<line>
        		<cell width="0.3"><text action="{name:admin' . $ctr . ',param:0}" halign="center">$f00' . $button['Name'] . '</text></cell>
        		<cell width="0.7"><text>$333 - ' . $button['Description'] . '</text></cell>
      			</line>';
	  		$window->addCallback('admin' . $ctr, $button['Funcname'], $button['Owner']);
			$ctr++;
		}
	  $window->setContent($content);
      $window->addCallback('close', 'closeAdmin');
      $this->storePlayerData($command['author'], 'window', $window);
    }
  }

	function addButton($button_name, $button_desc, $funcname, $owner)
		{
		$this->buttons[] = array('Name'=>$button_name, 'Description'=>$button_desc, 'Funcname'=>$funcname, 'Owner'=>$owner);
		}  //  addButton

  function closeAdmin($param, $window, $player) {
    $this->removePlayerData($player, 'window');
  }

  function nextMap() {
//    $this->Aseco->addCall('NextChallenge');
    $this->Aseco->client->query('NextChallenge');							// 08-4-23 BTM - no more waiting, send when you get it
    $this->sendServerMessage('$ff0>> Admin forced next challenge!');
  }

  function setServerName($command) {
//    $this->Aseco->addCall('SetServerName', array($command['params']));
    $this->Aseco->client->query('SetServerName', $command['params']);		// 08-4-23 BTM - no more waiting, send when you get it
    $this->sendServerMessage('$ff0>> Admin changed server name to "'.$command['params'].'"');
  }

  function restartMap() {
//    $this->Aseco->addCall('ChallengeRestart');
    $this->Aseco->client->query('ChallengeRestart');						// 08-4-23 BTM - no more waiting, send when you get it
    $this->sendServerMessage('$ff0>> Admin forced a challenge restart!');
  }

  function kickPlayer($command) {
//    $this->Aseco->addCall('Kick', array($command['params']));
    $this->Aseco->client->query('Kick', $command['params']);				// 08-4-23 BTM - no more waiting, send when you get it
    $this->sendServerMessage('$ff0>> Admin kicked player "'.$command['params'].'"!');
  }

  function banPlayer($command) {
//    $this->Aseco->addCall('Ban', array($command['params']));
    $this->Aseco->client->query('Ban', $command['params']);					// 08-4-23 BTM - no more waiting, send when you get it
    $this->sendServerMessage('$ff0>> Admin banned player "'.$command['params'].'"!');
  }

  function setMaxPlayers($command) {
//    $this->Aseco->addCall('SetMaxPlayers', array((int)$command['params']));
    $this->Aseco->client->query('SetMaxPlayers', (int)$command['params']);	// 08-4-23 BTM - no more waiting, send when you get it
    $this->sendServerMessage('$ff0>> Admin set a new player maximum of '.$command['params'].'!');
  }

  function showAdminToPlayer($player) {
    // simulate a chat command ...
    $this->Aseco->playerChat(array('author' => $player, 2 => '/admin'));
  }

  function init() {
    $statusbar = $this->Aseco->getPlugin('Statusbar');
    if ($statusbar) {
      $statusbar->addButton('Admin', $this, 'showAdminToPlayer', 0.095);
    }
	$this->addButton('Restart Track', 'Restart the current track immediately', 'restartMap', $this);
	$this->addButton('Next Track', 'Go to the next track immediately', 'nextMap', $this);
  }

}

$_PLUGIN = new Admin();
$_PLUGIN->setAuthor('Florian Schnell');
$_PLUGIN->setVersion(1.0);
$_PLUGIN->addChatCommand('admin ', 'showAdmin', 'displays the admin panel', 'adminpanel');
$_PLUGIN->addChatCommand('admin nextmap', 'nextMap', 'go to next map', 'adminnextmap');
$_PLUGIN->addChatCommand('admin restartmap', 'restartMap', 'restarts current map', 'adminrestart');
$_PLUGIN->addChatCommand('admin setsrvname', 'setServerName', 'sets a new server name', 'setservername');
$_PLUGIN->addChatCommand('admin kick', 'kickPlayer', 'kicks a player from the server', 'adminkick');
$_PLUGIN->addChatCommand('admin ban', 'banPlayer', 'bans a player for server uptime', 'adminban');
$_PLUGIN->addChatCommand('admin setmaxplayers', 'setMaxPlayers', 'sets a new server player max', 'setmaxplayers');
$_PLUGIN->addEvent('onStartup', 'init');
$_PLUGIN->setDescription('Provides admin only Chat Commands and an Admin Panel.');
?>
