<?php
/**
 * This is a little example how you could realize your
 * plugins with the new window system.
 **/

class Example extends Plugin {
  private $numbers;
  
  function doExample($command, $window = null) {
    if (!isset($window)) {
      $window = $this->createWindowToPlayerFramework('Examplewindow',
                                                     0.45,
                                                     0.3,
                                                     $command['author']);
      $this->numbers[$command['author']->login] = 0;
      $window->addCallback('increase', 'increaseNumber');
    }
    
    $window->setContent('<line><cell><text>$000Current number is '.++$this->numbers[$command['author']->login].'</text></cell></line>
    <line><cell><text action="{name:increase,param:0}">$f00Increase it</text></cell></line>');
    $window->addCallback('close', 'closing');
  }
  
  function closing($param, $window, $player) {
    unset($window);
  }
  
  function increaseNumber($param, $window, $player) {
    $command['author'] = $player;
    $this->doExample($command, $window);
  }
  
  function doExample2($command) {
    $message = 'This is an example popup!';
    $this->sendPopupWindowToPlayer($command['author']->login, $message, 'TestWindow', 10);
  }
}

$_PLUGIN = new Example();
$_PLUGIN->setAuthor('Florian Schnell');
$_PLUGIN->setVersion(1.0);
$_PLUGIN->addChatCommand('example', 'doExample', 'displays an example window');
$_PLUGIN->addChatCommand('popup', 'doExample2', 'displays an popup example');
?>
