<?php
/*
*******************************************************************************
** FufiWidgets by oorf | fuckfish (ASECO 2.0+ Version) ************************
*******************************************************************************
* First of all thanks to the SATO developers Trabtown and Phil who had most of
* the ideas first and developed the visual style.
*
* This plugin displays multiple graphical widgets on your server.
* There are the Local Records widget, a Live Rankings widget, a Karma widget,
* a Challenge widget and a Clock widget.
*
*
*******************************************************************************
* INSTALLATION                                                                *
*******************************************************************************
* Important! If you don't follow the steps carefully, the plugin will not be
* working properly.
* 1. Unrar the archive into the ASECO folder
* 2. Open aseco.php
*
*         - find the lines (around line 700)
*         		case 'TrackMania.PlayerManialinkPageAnswer':
* 					$player = $this->server->players->getPlayer($call[1][1]);
* 					$player->framework->releaseWindowEvent($call[1][2], $player);
* 					break;
*
* 		   - change them to
*					case 'TrackMania.PlayerManialinkPageAnswer':
*					$player = $this->server->players->getPlayer($call[1][1]);
* 					$this->releaseEvent('onPlayerManialinkPageAnswer', $call[1]);
* 					$player->framework->releaseWindowEvent($call[1][2], $player);
* 					break;
*
* 			- find the lines (around line 690)
*					if ($this->server->gameinfo->getMode() != $mode) {
* 						$this->console('gamemode changed ['.$mode.'] >> ['.$this->server->gameinfo->getMode().']');
* 					}
*
* 			- change them to
*					if ($this->server->gameinfo->getMode() != $mode) {
* 						$this->console('gamemode changed ['.$mode.'] >> ['.$this->server->gameinfo->getMode().']');
* 						$this->releaseEvent('onGameModeChange', null);
* 					}
* 3. Configure some stuff if you like to (see configuration section)
* 3. Done! Have fun!
*
*
*******************************************************************************
* CONFIGURATION                                                               *
*******************************************************************************
* You can adjust the configuration in the pretty self explaining
* "fufi_widgets_config.xml". You can also take a shot in pimping the graphical
* output by editing the XML files in the "./plugins/fufi" folder.
*
*
*******************************************************************************
* The Challenge widget                                                        *
*******************************************************************************
* This one replaces the original challenge info in the upper right of the
* screen with something more fancy =) It adds the display of a logo, the
* author time and if you click it it will also show gold, silver and
* bronze time and a TMX link (if you installed oliverde8's TMX-Info plugin
* (http://www.tm-forum.com/viewtopic.php?f=28&t=14926))
*
*
*******************************************************************************
* The Local Records widget                                                    *
*******************************************************************************
* This one just displays the local records on your server in a defined area
* customized for every player individually.
*
*
*******************************************************************************
* The Live Rankings widget                                                    *
*******************************************************************************
* This widget displays the current scoreboard in the same style like the local
* records widget.
*
*
*******************************************************************************
* The Karma Widget                                                            *
*******************************************************************************
* This one displays the track karma graphically and provides buttons to karma
* vote via mouse click.
*
*******************************************************************************
* The Clock widget                                                            *
*******************************************************************************
* It's just a clock ;-)
*
*
*/

/**
 * The FufiWidgets Plugin
 * 
 * @author oorf | fuckfish
 */
class FufiWidgets extends Plugin {

	private $challengeWidgetID, $closeToYouWidgetID, $manialinksID, $karmaWidgetID, $rankingWidgetID, $clockWidgetID;
	private $racing;
	private $localRecordsHashs, $liveRankingHashs;
	private $karmaHashs;
	private $lastShownKarma;
	private $localRecordsCount, $liveRankingsCount;
	private $localTime;
	var $settings;

	/**
	 * Initializes the plugin, loads the XML settings
	 */
	function init(){
		$this->loadSettings();

		// create some "unique" IDs for capturing clicks and updating the manialinks
		$this->manialinksID = "382";
		$this->challengeWidgetID = $this->manialinksID.'001';
		$this->closeToYouWidgetID = $this->manialinksID.'002';
		$this->karmaWidgetID = $this->manialinksID.'003';
		$this->rankingWidgetID = $this->manialinksID.'004';
		$this->clockWidgetID = $this->manialinksID.'005';

		// initialize some arrays and values
		$this->karmaHashs = Array();
		$this->lastShownKarma = -1;
		$this->localRecordsHashs = array();
		$this->liveRankingHashs = array();
		$this->localTime = "";
	}

	/**
	 * Converts a string to a boolean
	 *
	 * @param String $string
	 * @return boolean
	 */
	function stringToBool($string){
		if (strtoupper($string)=="FALSE" || $string=="0") return false;
		return true;
	}

	/**
	 * Loads the settings from the XML file and stores them 
	 * to the local variable $settings
	 */
	function loadSettings(){
		$this->settings = array();
		$xml = simplexml_load_file('settings/fufi_widgets_config.xml');

		//get karmawidget settings

		$karmaSettings = array();
		$karmaSettings["enabled"] = $this->stringToBool(strval($xml->karmawidget->enabled));
		$karmaSettings["title"] = strval($xml->karmawidget->title);
		$karmaSettings["states"] = array();
		foreach ($xml->karmawidget->states->state as $state){
			$id = intval($state["id"]);
			$x = strval($state->x);
			$y = strval($state->y);
			$pos = $x.' '.$y.' 0';
			$displaytitle = $this->stringToBool(strval($state->displaytitle));
			$karmaSettings["states"][$id]=array();
			$karmaSettings["states"][$id]["pos"]=$pos;
			$karmaSettings["states"][$id]["displaytitle"]=$displaytitle;
		}
		$karmaSettings["xml"]=file_get_contents('./plugins/fufi/fufi_karmaWidget.xml');
		$this->settings["karmawidget"] = $karmaSettings;

		//get clockwidget settings

		$clockSettings = array();
		$clockSettings["enabled"] = $this->stringToBool(strval($xml->clockwidget->enabled));
		$clockSettings["timeformat"] = strval($xml->clockwidget->timeformat);
		$clockSettings["states"] = array();
		foreach ($xml->clockwidget->states->state as $state){
			$id = intval($state["id"]);
			$x = strval($state->x);
			$y = strval($state->y);
			$pos = $x.' '.$y.' 0';
			$clockSettings["states"][$id]=array();
			$clockSettings["states"][$id]["pos"]=$pos;
		}
		$clockSettings["xml"]=file_get_contents('./plugins/fufi/fufi_clockWidget.xml');
		$this->settings["clockwidget"] = $clockSettings;

		//get challengewidget settings

		$challengeSettings = array();
		$challengeSettings["enabled"] = $this->stringToBool(strval($xml->challengewidget->enabled));
		$challengeSettings["states"] = array();
		foreach ($xml->challengewidget->states->state as $state){
			$id = intval($state["id"]);
			$x = strval($state->x);
			$y = strval($state->y);
			$pos = $x.' '.$y.' 0';
			$challengeSettings["states"][$id]=array();
			$challengeSettings["states"][$id]["pos"]=$pos;
		}
		$challengeSettings["xml"]=file_get_contents('./plugins/fufi/fufi_challengeWidget.xml');
		$this->settings["challengewidget"] = $challengeSettings;


		//get localrecordswidget settings

		$localRecordsSettings = array();
		$localRecordsSettings["enabled"] = $this->stringToBool(strval($xml->localrecordswidget->enabled));
		$localRecordsSettings["title"] = strval($xml->localrecordswidget->title);
		$localRecordsSettings["states"] = array();
		foreach ($xml->localrecordswidget->states->state as $state){
			$id = intval($state["id"]);
			$enabled = $this->stringToBool(strval($state->enabled));
			$entrycount = intval($state->entrycount);
			$x = strval($state->x);
			$y = strval($state->y);
			$pos = $x.' '.$y.' 0';
			$width = strval($state->width);
			$localRecordsSettings["states"][$id]=array();
			$localRecordsSettings["states"][$id]["width"]=$width;
			$localRecordsSettings["states"][$id]["enabled"]=$enabled;
			$localRecordsSettings["states"][$id]["entrycount"]=$entrycount;
			$localRecordsSettings["states"][$id]["pos"]=$pos;
		}
		$localRecordsSettings["xml"]=file_get_contents('./plugins/fufi/fufi_recordWidget.xml');
		$this->settings["localrecordswidget"] = $localRecordsSettings;


		//get liverankingswidget settings

		$liveRankingsSettings = array();
		$liveRankingsSettings["enabled"] = $this->stringToBool(strval($xml->liverankingswidget->enabled));
		$liveRankingsSettings["title"] = strval($xml->liverankingswidget->title);
		$liveRankingsSettings["states"] = array();
		foreach ($xml->liverankingswidget->states->state as $state){
			$id = intval($state["id"]);
			$enabled = $this->stringToBool(strval($state->enabled));
			$entrycount = intval($state->entrycount);
			$x = strval($state->x);
			$y = strval($state->y);
			$pos = $x.' '.$y.' 0';
			$width = strval($state->width);
			$liveRankingsSettings["states"][$id]=array();
			$liveRankingsSettings["states"][$id]["width"]=$width;
			$liveRankingsSettings["states"][$id]["enabled"]=$enabled;
			$liveRankingsSettings["states"][$id]["entrycount"]=$entrycount;
			$liveRankingsSettings["states"][$id]["pos"]=$pos;
		}
		$liveRankingsSettings["xml"]=$localRecordsSettings["xml"];
		$this->settings["liverankingswidget"] = $liveRankingsSettings;

	}


	/**
	 * Extracts a specific marked block from the manialink XML templates
	 * in the folder "./plugins/fufi"
	 *
	 * @param String $haystack
	 * @param String $caption
	 * @return The requested block in a String
	 */
	function getXMLBlock($haystack, $caption){
		$startStr = '<!--start_'.$caption.'-->';
		$endStr = '<!--end_'.$caption.'-->';
		$haystack = substr($haystack, strpos($haystack, $startStr) + strlen($startStr));
		$haystack = substr($haystack, 0, strpos($haystack, $endStr));
		return ($haystack);
	}

	/**
	 * Extracts multiple XML blocks and combines them
	 *
	 * @param String $haystack
	 * @param mixed $parts
	 * @return The requested blocks merged in a String
	 */
	function buildXML ($haystack, $parts){
		$result = "";
		foreach ($parts as $part){
			$result .= $this->getXMLBlock($haystack, $part);
		}
		return $result;
	}

	/**
	 * Executes Karma votes
	 *
	 * @param String $login
	 * @param String $action
	 */
	function executeKarma($login, $action){
		$cmd=array();
		$cmd['author'] = $this->Aseco->server->players->getPlayer($login);
		$raspKarma = $this->Aseco->getPlugin('RaspKarma');
		if ($action==1){
			$raspKarma->KarmaVote($cmd, -1);
		} else if ($action==2){
			$raspKarma->KarmaVote($cmd, 1);
		}

		$this->showKarmaWidget();
	}

	/**
	 * Searches the chat for karma commands and reacts on them
	 *
	 * @param mixed $command
	 */
	function check4KarmaChatText(&$command)
	{
		if ($command[2] == '++' || $command[2] == '--'){
			$this->showKarmaWidget();
		}
	}


	/**
	 * Displays the Karma widget to all or , if specified, 
	 * only to the given login
	 *
	 * @param String $login
	 */
	function showKarmaWidget($login=''){
		
		if (!$this->settings["karmawidget"]["enabled"]) return;

		$challenge = $this->Aseco->server->challenge;

		//get some karma values from the database (large portions stolen from the RaspKarma plugin

		$query = 'Select goodkarma from challenges WHERE Id=' . $challenge->data['DB_ID'];
		$res = mysql_query($query);
		if ( mysql_num_rows($res) == 1 ){
			$row = mysql_fetch_row($res);
			$goodkarma = $row[0];
		} else {
			$goodkarma = 0;
		}

		if ( !isset($goodkarma) ){
			$goodkarma = 0;
		}
		mysql_free_result($res);

		$query = 'Select badkarma from challenges WHERE Id=' . $challenge->data['DB_ID'];
		$res = mysql_query($query);
		if ( mysql_num_rows($res) == 1 ){
			$row = mysql_fetch_row($res);
			$badkarma = abs($row[0]);
		} else {
			$badkarma = 0;
		}

		if ( !isset($badkarma) ){
			$badkarma = 0;
		}

		mysql_free_result($res);

		$totkarma = $badkarma + $goodkarma;

		$totalCups = 8;
		$glowCups = 0;
		if ($totkarma) $glowCups = round($goodkarma/$totkarma*$totalCups);


		//get the manialink XML template for the widget and separate it to blocks

		$page = $this->settings["karmawidget"]["xml"];
		$xml = $this->buildXML($page, array("header", "window"));
		$title = $this->buildXML($page, array("title"));
		$glowAward = $this->buildXML($page, array("glow_award"));
		$award = $this->buildXML($page, array("award"));
		$highlightMinus = $this->buildXML($page, array("highlight_minus"));
		$highlightPlus = $this->buildXML($page, array("highlight_plus"));
		$minus = $this->buildXML($page, array("minus"));
		$plus = $this->buildXML($page, array("plus"));
		$footer= $this->buildXML($page, array("footer"));

		//replace the placeholders in the xml blocks with content

		for ($i=0; $i< $totalCups; $i++){
			$x = 1.2*$i+1.3;
			$y = -2.5;
			$width = 1.6+($i/$totalCups)*0.6;
			if ($i<$glowCups){
				$aw = $glowAward;
			} else {
				$aw = $award;
			}
			$icon = str_replace(array('%width%', '%x%', '%y%'), array($width, $x, $y), $aw);
			$xml.=$icon;
		}

		//the gamemode is needed to get the right configuration and display options
		$gamemode = $this->Aseco->server->gameinfo->mode;
		$title = str_replace('%widgettitle%', $this->settings["karmawidget"]["title"], $title);
		$xml = str_replace(array('%manialinksid%', '%widgetid%', '%widgetpos%'), array($this->manialinksID, $this->karmaWidgetID.'000', $this->settings["karmawidget"]["states"][$gamemode]["pos"]), $xml);
		if ($this->settings["karmawidget"]["states"][$gamemode]["displaytitle"]) $xml.=$title;
		$xml.=$footer;




		//show the global part of the karma widget if necessary

		if ($this->lastShownKarma!=$glowCups||$login){
			if ($login){
				$this->Aseco->client->addCall("SendDisplayManialinkPageToLogin", array($login, $xml, 0, false));
			} else {
				$this->lastShownKarma = $glowCups;
				$this->Aseco->client->addCall("SendDisplayManialinkPage", array($xml, 0, false));
			}
		}


		//all below: create player specific manialink parts


		//replace the placeholders in the xml blocks with content

		$xml = $this->buildXML($page, array("header"));
		$xml = str_replace(array('%manialinksid%', '%widgetid%', '%widgetpos%'), array($this->manialinksID, $this->karmaWidgetID, $this->settings["karmawidget"]["states"][$gamemode]["pos"]), $xml);

		$votedPlus = $xml.str_replace(array('%action%'), array(''), $plus).str_replace(array('%action%'), array('action="'.$this->karmaWidgetID.'1"'), $minus).$highlightPlus.$footer;
		$votedMinus = $xml.str_replace(array('%action%'), array(''), $minus).str_replace(array('%action%'), array('action="'.$this->karmaWidgetID.'2"'), $plus).$highlightMinus.$footer;
		$notVoted = $xml.str_replace(array('%action%'), array('action="'.$this->karmaWidgetID.'1"'), $minus).str_replace(array('%action%'), array('action="'.$this->karmaWidgetID.'2"'), $plus).$footer;


		//get player specific karma votes from the database
		$query = 'select * from rs_karma where ChallengeId='.$challenge->data['DB_ID'];
		$res = mysql_query($query);
		$votes = array();

		for ($i=0; $i<mysql_num_rows($res); $i++){
			$playerID=mysql_result($res, $i, 'PlayerId');
			$votes["".$playerID] = mysql_result($res, $i, 'Score');
		}

		//show the player specific part of the karma widget to the players if necessary

		foreach ($this->Aseco->server->players->player_list as $player){
			$query = "select id from players where login='".$player->login."'";
			$res = mysql_query($query);
			if (mysql_num_rows($res)){
				$playerID = mysql_result($res, 0, 'id');
			} else {
				$playerID = -1;
			}
			$voted = $votes["".$playerID];
			if ($voted==-1){
				$xml_ = $votedMinus;
			} else if ($voted==1){
				$xml_ = $votedPlus;
			} else {
				$xml_ = $notVoted;
			}

			if (!isset($this->karmaHashs[$player->login])) $this->karmaHashs[$player->login] = -2;

			//only sends manialink if it changed
			if ($this->karmaHashs[$player->login]!=$voted){
				$this->karmaHashs[$player->login]=$voted;
				$this->Aseco->client->addCall("SendDisplayManialinkPageToLogin", array($player->login, $xml_ , 0, false));
			}

		}

	}

	/**
	 * Creates a blank array with a specified length
	 *
	 * @param int $ctuCount The number of entries in the array
	 * @return mixed
	 */
	function blankCTUArray($ctuCount){
		$result = array();
		for ($i=0; $i<$ctuCount; $i++){
			$result[$i]=null;
		}
		return $result;
	}

	/**
	 * Creates an array needed for the Local Records widget and the Live Rankings widget
	 * for a specific player
	 *
	 * @param mixed $records
	 * @param string $login
	 * @param int $ctuCount
	 * @return a specialized array
	 */
	function getCloseToYouArray($records, $login, $ctuCount){

		$playerObj = $this->Aseco->server->players->getPlayer($login);
		$player = new RecPlayer($playerObj);
		$result = $this->blankCTUArray($ctuCount);
		$better = array();
		$self = null;
		$worse = array();

		$isbetter=true;

		//constructs arrays with records of better and worse players than the specified player
		for ($i=0; $i<count($records); $i++){
			$entry = $records[$i];
			$entry["rank"]=$i+1;
			if ($isbetter){
				if ($records[$i]["player"]->login == $login){
					$self = $entry;
					$isbetter = false;
				} else {
					$better[]=$entry;
				}
			} else {
				$worse[] = $entry;
			}
		}

		//go through the possibile scenarios and choose the right one (wow, what an explanation^^)
		if (!$self){
			$lastIdx = $ctuCount - 1;
			$result[$lastIdx]=array();
			$result[$lastIdx]["rank"]=0;
			$result[$lastIdx]["player"]=$player;
			$result[$lastIdx]["score"]=0;
			$result[$lastIdx]["self"]=0;
			for($i=count($better)-1; $i>=0; $i--){
				if (--$lastIdx>=0){
					$result[$lastIdx]=$better[$i];
					$result[$lastIdx]["self"]=-1;
				}
			}
		} else {
			$hasbetter=true;
			$hasworse=true;
			$resultNew = array();

			$resultNew[0] = $self;
			$resultNew[0]["self"]=0;

			$idx=0;
			$toggleBetterWorse=true;
			while (count($resultNew)<$ctuCount && ($hasbetter||$hasworse)){

				if ($hasbetter && (count($better)>= ($idx+1))){

					//push one record before
					$rec = $better[count($better)-1-$idx];
					$rec["self"]=-1;
					$help=array();
					$help[0]=$rec;
					for ($i=0; $i<count($resultNew); $i++){
						$help[$i+1]=$resultNew[$i];
					}
					$resultNew = $help;
				} else {
					$hasbetter = false;
				}
				if ($hasworse && (count($worse)>= ($idx+1))){

					//push one record behind
					$rec = $worse[$idx];
					$rec["self"]=1;
					$resultNew[]=$rec;
				} else {
					$hasworse = false;
				}
				$idx++;
			}
			$result = $resultNew;
		}

		$resultNew=array();
		for ($i=0; $i<count($result); $i++){
			if ($result[$i]!=null) $resultNew[]=$result[$i];
		}
		$result = $resultNew;

		return $result;
	}

	/**
	 * Creates a hash value out of a Close2You entry
	 *
	 * @param array $arr
	 * @return a md5 hash string
	 */
	function ctuHash($arr){
		$result = "";
		for ($i=0; $i<count($arr); $i++){
			$result.= $arr[$i]["rank"];
			$result.= $arr[$i]["player"]->login;
			$result.= $arr[$i]["score"];
		}
		return md5($result);
	}

	/**
	 * Creates a manialink string for an entry for the Close2You widgets
	 *
	 * @param array $rec
	 * @param int $i
	 * @param String $highlite
	 * @param String $entry
	 * @param boolean $showPoints
	 * @return The manialink string
	 */
	function getCTUEntry($rec, $i, $highlite, $entry, $showPoints){

		//$showpoints actually means that the widget calling that function wants to display points and not times

		if (!$showPoints){
			$score = substr(formatTime($rec["score"]),1);
		} else {
			$score = $rec["score"].'   ';
		}

		//some gui formatting and replacement

		$nick = str_replace('$w', '', $rec["player"]->nickname);
		$nick = str_replace('$i', '', $nick);
		$rank = $rec["rank"];
		if ($rec["score"]==0){
			$rank = '--';
			if (!$showPoints) $score='-:--.--';
		}
		if ($rec["self"]==-1) $score = '$f00'.$score;
		else if ($rec["self"]==1) $score = '$08f'.$score;
		else {
			$score = '$3f5'.$score;
			$y=-2*$i-0.9;
			$highlite_ = str_replace(array("%y%"), array($y), $highlite);
			$entry.=$highlite_;
		}
		$entry_ = str_replace(array("%x_rank%", "%y%", "%rank%", "%x_score%", "%score%", "%x_nick%", "%nick%"),	array(2.5, -2*$i-1.2, $rank.'.', 6.8, $score, 7.2, htmlspecialchars($nick)), $entry);
		return $entry_;

	}

	/**
	 * Shows the Local Record widget and the Live Rankings widget to all players.
	 *
	 * @param boolean $playerFinished Determines whether this function was called in result to the OnPlayerFinished event
	 */
	function showRecordsWidgets($playerFinished=false){

		//the gamemode is needed to get the right configuration and display options
		$gamemode = $this->Aseco->server->gameinfo->mode;
		$roundsmode = $gamemode==0 || $gamemode==5;

		$showLocalRecs = $this->settings["localrecordswidget"]["enabled"] && $this->settings["localrecordswidget"]["states"][$gamemode]["enabled"];
		$showLiveRankings = $this->settings["liverankingswidget"]["enabled"] && $this->settings["liverankingswidget"]["states"][$gamemode]["enabled"];

		//in roundsmode, there is no need to react onPlayerFinish
		if ($roundsmode && $playerFinished) $showLiveRankings = false;

		if (!($showLiveRankings || $showLocalRecs)) return;



		//get the manialink XML template for the widget and separate it to blocks

		$page = $this->settings["localrecordswidget"]["xml"];
		$header = $this->buildXML($page, array("header"));
		$header = str_replace(array("%manialinksid%"), array($this->manialinksID), $header);
		$footer = $this->buildXML($page, array("footer"));
		$footer_window = $this->buildXML($page, array("footer_window"));
		$entry = $this->buildXML($page, array("entry"));
		$highlite = $this->buildXML($page, array("highlight_entry"));
		$localRecordsCount = $this->settings["localrecordswidget"]["states"][$gamemode]["entrycount"];
		$liveRankingsCount = $this->settings["liverankingswidget"]["states"][$gamemode]["entrycount"];


		//local record stuff

		if ($showLocalRecs){

			//replace the placeholders in the xml blocks with content

			$headerLocalRecs = $this->buildXML($page, array("header_window", "window"));
			$headerLocalRecs = str_replace(array("%widgetid%", "%height%", "%width%", "%titlepos%",  "%widgettitle%", "%widgetpos%") , array($this->closeToYouWidgetID, 2*$localRecordsCount+2, $this->settings["localrecordswidget"]["states"][$gamemode]["width"],$this->settings["localrecordswidget"]["states"][$gamemode]["width"]/2, $this->settings["localrecordswidget"]["title"], $this->settings["localrecordswidget"]["states"][$gamemode]["pos"]), $headerLocalRecs);
			$highliteLocalRecs = str_replace('%width%', $this->settings["localrecordswidget"]["states"][$gamemode]["width"], $highlite);

			//get the records from Aseco

			$records = array();
			for ($i=0; $i<$this->Aseco->records->count(); $i++){
				$records[$i] = array();
				$rec = $this->Aseco->records->getRecord($i);
				$records[$i]["player"] =  $rec->player;
				$records[$i]["score"] = $rec->score;
			}
		}


		//live rankings stuff

		if ($showLiveRankings){

			//replace the placeholders in the xml blocks with content

			$headerLiveRecs = $this->buildXML($page, array("header_window", "window"));
			$headerLiveRecs = str_replace(array("%widgetid%", "%height%", "%width%", "%titlepos%", "%widgettitle%", "%widgetpos%"), array($this->rankingWidgetID, 2*$liveRankingsCount+2,  $this->settings["liverankingswidget"]["states"][$gamemode]["width"],$this->settings["liverankingswidget"]["states"][$gamemode]["width"]/2, $this->settings["liverankingswidget"]["title"], $this->settings["liverankingswidget"]["states"][$gamemode]["pos"]), $headerLiveRecs);
			$highliteLiveRankings = str_replace('%width%', $this->settings["liverankingswidget"]["states"][$gamemode]["width"], $highlite);



			//get the current rankings

			$this->Aseco->client->multiquery();
			$this->Aseco->client->addCall("GetCurrentRanking", array(500,0));
			$this->Aseco->client->multiquery();
			$rankings = $this->Aseco->client->getResponse();
			$rankings = $rankings[0][0];
			$rankings_= array();

			for ($i=0; $i<count($rankings); $i++){
				if ($rankings[$i]["BestTime"]==0) $rankings[$i]["BestTime"]= $rankings[$i]["Score"];
				if ($rankings[$i]["BestTime"]>0){
					$playerObj = $this->Aseco->server->players->getPlayer($rankings[$i]["Login"]);
					$player = new RecPlayer($playerObj);
					$ranking = array();
					$ranking["player"] = $player;
					$ranking["player"]->nickname = $rankings[$i]["NickName"];
					$ranking["score"] = $rankings[$i]["BestTime"];
					if ($gamemode==0 || $gamemode==4 || $gamemode==5){
						$ranking["score"] = $rankings[$i]["Score"];
					}

					$rankings_[]= $ranking;
				}
			}

			$rankings = $rankings_;

		}

		$showpoints = false;

		foreach ($this->Aseco->server->players->player_list as $player){


			//local records stuff (create the Close2You array and a hash value)

			if ($showLocalRecs){

				$localRecordsCtu = $this->getCloseToYouArray($records, $player->login, $localRecordsCount);
				$localRecordsCtuHash = $this->ctuHash($localRecordsCtu);

				if (!isset($this->localRecordsHashs[$player->login])){
					$this->localRecordsHashs[$player->login]="-1";
				}
			}


			//live rankings stuff (create the Close2You array and a hash value)

			if ($showLiveRankings){

				$liveRankingCtu = $this->getCloseToYouArray($rankings, $player->login, $liveRankingsCount);
				$liveRankingCtuHash = $this->ctuHash($liveRankingCtu);

				if (!isset($this->liveRankingHashs[$player->login])){
					$this->liveRankingHashs[$player->login]="-1";
				}
			}

			// only update the widget manialink if something changed

			if (($this->localRecordsHashs[$player->login] != $localRecordsCtuHash) || ($this->liveRankingHashs[$player->login] != $liveRankingCtuHash)){
				$localRecContent = '';
				$liveRankingContent = '';


				// local records stuff (create the new widget manialink, if necessary)

				if (($this->localRecordsHashs[$player->login] != $localRecordsCtuHash) && $showLocalRecs){
					$this->localRecordsHashs[$player->login] = $localRecordsCtuHash;

					if ($gamemode==4) $showpoints = true;

					for ($i=0;$i<count($localRecordsCtu); $i++){

						$localRecContent.= str_replace('%nickwidth%', $this->settings["localrecordswidget"]["states"][$gamemode]["width"]-8.5, $this->getCTUEntry($localRecordsCtu[$i], $i, $highliteLocalRecs, $entry, $showpoints));

					}
					$localRecContent = $headerLocalRecs.$localRecContent.$footer_window;
				}

				// local records stuff (create the new widget manialink, if necessary)

				if (($this->liveRankingHashs[$player->login] != $liveRankingCtuHash) && $showLiveRankings){
					$this->liveRankingHashs[$player->login] = $liveRankingCtuHash;

					if ($gamemode==0 || $gamemode==4 || $gamemode==5) $showpoints = true;

					for ($i=0;$i<count($liveRankingCtu); $i++){

						$liveRankingContent.=str_replace('%nickwidth%', $this->settings["liverankingswidget"]["states"][$gamemode]["width"]-8.5, $this->getCTUEntry($liveRankingCtu[$i], $i, $highliteLiveRankings, $entry, $showpoints));

					}
					$liveRankingContent = $headerLiveRecs.$liveRankingContent.$footer_window;
				}

				// send it
				$xml = $header.$localRecContent.$liveRankingContent.$footer;
				$this->Aseco->client->addCall("SendDisplayManialinkPageToLogin", array($player->login, $xml , 0, false));

			}
		}
	}

	/**
	 * Shows the Clock widget
	 *
	 */
	function showClockWidget(){
		if (!$this->settings["clockwidget"]["enabled"]) return;

		$time = time();
		$localTime = date($this->settings["clockwidget"]["timeformat"], time());


		//sends the new time if necessary

		if ($localTime!=$this->localTime){
			$this->localTime = $localTime;
			$page = $this->settings["clockwidget"]["xml"];
			$page = str_replace(array("%manialinksid%", "%widgetid%", "%widgetpos%", "%time%"), array($this->manialinksID, $this->clockWidgetID, $this->settings["clockwidget"]["states"]["0"]["pos"], $this->localTime), $page);
			$this->Aseco->client->addCall("SendDisplayManialinkPage", array($page , 0, false));
		}
	}

	/**
	 * Shows the Challenge widget to all or to a specific player
	 *
	 * @param String $login
	 * @param int $state 0..default 1..expanded
	 */
	function showChallengeInfo($login, $state = 0){
		if (!$this->settings["challengewidget"]["enabled"]) return;


		//little workaround that displays a tmx button if the tmxinfo plugin is available
		
		$tmxInfo = $this->Aseco->getPlugin('TMX_info');

		if ($tmxInfo && ($state == 2)){
			$command = array();
			$command['author']= $this->Aseco->server->players->getPlayer($login);
			$tmxInfo->TMX_info_manialink($command);
			return;
		}
		if (!$tmxInfo && $state==1){
			$state = 2;

		}


		$challenge = $this->Aseco->server->challenge;

		//get the manialink XML template for the widget and separate it to blocks (depends on state id)

		$page = $this->settings["challengewidget"]["xml"];

		if ($state == 0){
			$page = $this->buildXML($page, array("header", "defaultstate", "footer"));
		} else if ($state == 1){
			$page = $this->buildXML($page, array("header", "maxstate", "footer"));
		} else if ($state == 2){
			$page = $this->buildXML($page, array("header", "maxstatenotmx", "footer"));
		}

		//replace the placeholders in the xml blocks with content

		$page = str_replace(array("%manialinksid%", "%widgetid%", "%widgetpos%", "%trackname%", "%bronzetime%", "%silvertime%", "%goldtime%", "%authortime%", "%author%"),
		array($this->manialinksID,	$this->challengeWidgetID, $this->settings["challengewidget"]["states"][$state]["pos"], $challenge->name, formatTime($challenge->bronzetime), formatTime($challenge->silvertime), formatTime($challenge->goldtime), formatTime($challenge->authortime), $challenge->author), $page);
		if ($login){
			$this->Aseco->client->addCall("SendDisplayManialinkPageToLogin", array($login, $page , 0, false));
		} else {
			$this->Aseco->client->addCall("SendDisplayManialinkPage", array($page , 0, false));
		}
	}

	/**
	 * Hide the Clock widget
	 */
	function hideClockWidget(){
		$this->hideWidget($this->clockWidgetID);
		$this->localTime="";
	}

	/**
	 * Hide the Karma widget
	 */
	function hideKarmaWidget(){
		$this->lastShownKarma=-1;
		$this->karmaHashs = array();
		$this->hideWidget($this->karmaWidgetID);
		$this->hideWidget($this->karmaWidgetID.'000');
	}

	/**
	 * Hide the Challenge widget
	 */
	function hideChallengeInfo(){
		$this->hideWidget($this->challengeWidgetID);
	}

	/**
	 * Hide the Local Records widget and the Live Rankings widget
	 */
	function hideRecordsWidgets(){
		$this->hideWidget($this->closeToYouWidgetID);
		$this->hideWidget($this->rankingWidgetID);
		$this->localRecordsHashs = array();
		$this->liveRankingHashs = array();
	}

	/**
	 * Hide a widget by its ID (send an empty one)
	 *
	 * @param int $id
	 */
	function hideWidget($id){
		$page = '<?xml version="1.0" encoding="UTF-8"?>
 					<manialinks id="'.$this->manialinksID.'">
   						<manialink id="'.$id.'">
   						</manialink>
   					</manialinks>
 				 ';		
		$this->Aseco->client->addCall("SendDisplayManialinkPage", array($page , 0, true));
	}

	/**
	 * Show the widgets for the racing state to all or a specific player
	 *
	 * @param String $login
	 */
	function showRaceWidgets($login=''){
		$this->showChallengeInfo($login);
		$this->showRecordsWidgets();
		$this->showKarmaWidget($login);
		$this->showClockWidget();
	}

	/**
	 * hides all widgets for the racing state
	 */
	function hideRaceWidgets(){
		$this->hideChallengeInfo();
		$this->hideRecordsWidgets();
		$this->hideKarmaWidget();
		$this->hideClockWidget();
	}


	/**
	 * Show the widgets for the scoreboard state to all or a specific player
	 *
	 * @param String $login
	 */
	function showScoreWidgets($login=''){

	}

	/**
	 * hides all widgets for the scoreboard state
	 */
	function hideScoreWidgets(){

	}

	/**
	 * Is called on newChallenge event and eventually on Status change to 4, initializes the racing state
	 */
	function doNewChallenge(){

		if (!$this->racing){
			$this->racing = true;
			$this->hideScoreWidgets();
			$this->showRaceWidgets();
		}
	}

	/**
	 * Is called on endRace event, initializes the scoreboard widgets
	 */
	function doEndRace(){
		$this->racing = false;
		$this->hideRaceWidgets();
		$this->showScoreWidgets();
	}

	/**
	 * Is called, when a player connects and initializes his widgets
	 *
	 * @param mixed $command
	 */
	function doPlayerConnect($command){
		if ($this->settings["challengewidget"]["enabled"]) $command->framework->setUIChallengeInfo(false);
		if ($this->racing){
			$this->showRaceWidgets($command->login);
		} else {
			$this->showScoreWidgets($command->login);
		}
	}
	
	/**
	 * Is called, when a player disconnects and deletes his hashs
	 *
	 * @param mixed $command
	 */
	function doPlayerDisconnect($command){
		unset($this->localRecordsHashs[$command->login]);
		unset($this->liveRankingHashs[$command->login]);
		unset($this->karmaHashs[$command->login]);
	}

	/**
	 * Handles mouse clicks on the widgets
	 *
	 * @param mixed $command
	 */
	function doHandleClick($command){

		$action = $command[2].'';
		if (substr($action, 0, strlen($this->manialinksID)) == $this->manialinksID){

			$action = substr($action, strlen($this->manialinksID));
			$recipient = substr($action, 0, 3);
			$action = substr($action, 3);

			if ($recipient=="001"){
				$this->showChallengeInfo($command[1], $action);
			} else if ($recipient=="003"){
				$this->executeKarma($command[1], $action);
			}

		}
	}

	/**
	 * debug output
	 * 
	 * @ignore Just do it =)
	 * @param unknown_type $command
	 */
	function debug($command){
		var_dump($command);
	}

	/**
	 * Forces the refreshing of the Karma widget
	 *
	 * @param mixed $command
	 */
	function doKarmaRefresh($command){
		$this->showKarmaWidget();
	}

	/**
	 * Reacts onMainLoop (needed for the clock)
	 */
	function doMainLoop(){
		if ($this->racing){
			$this->showClockWidget();
		}
	}


	function resetWidgets(){
		$this->localRecordsHashs = array();
		$this->liveRankingHashs = array();
		$this->lastShownKarma=-1;
		$this->karmaHashs = array();

		$this->hideScoreWidgets();
		$this->hideRaceWidgets();

		foreach ($this->Aseco->server->players->player_list as $player){
			$this->doPlayerConnect($player);
		}

	}
	/**
	 * Reacts onGameModeChange (needed for laying out the widgets)
	 */
	function doGameModeChange(){
		$this->resetWidgets();
	}

	/**
	 * Reacts onEndRound (used for the switching between the states)
	 */
	function doEndRound(){
		if ($this->Aseco->server->gameinfo->mode == 0 || $this->Aseco->server->gameinfo->mode == 0){
			$this->showRecordsWidgets();
		}
	}

	/**
	 * Reacts onPlayerFinish (refreshes the Close2You widgets if needed)
	 */
	function doPlayerFinish(){
		$this->showRecordsWidgets(true);
	}

}

// Initialization of the FufiWidgets

$_PLUGIN = new FufiWidgets();
$_PLUGIN->init();
$_PLUGIN->setAuthor('Alexander Peitz');
$_PLUGIN->setVersion(0.5);
$_PLUGIN->setDescription('Displays and manages graphical widgets.');

if ($_PLUGIN->settings["karmawidget"]["enabled"]){
	$_PLUGIN->addDependence("RaspKarma", 1);
	$_PLUGIN->addEvent('onChat', 'check4KarmaChatText');
	$_PLUGIN->addChatCommand('++', 'doKarmaRefresh', 'increases karma for the current track');
	$_PLUGIN->addChatCommand('--', 'doKarmaRefresh', 'decreases karma for the current track');
}

if ($_PLUGIN->settings["localrecordswidget"]["enabled"] || $_PLUGIN->settings["karmawidget"]["enabled"]){
	$_PLUGIN->addDependence("LocalDb", 1);
}

if ($_PLUGIN->settings["clockwidget"]["enabled"]){
	$_PLUGIN->addEvent('onMainLoop', 'doMainLoop');
}

$_PLUGIN->addEvent('onNewChallenge', 'doNewChallenge');
$_PLUGIN->addEvent('onEndRace', 'doEndRace');
$_PLUGIN->addEvent('onPlayerConnect', 'doPlayerConnect');
$_PLUGIN->addEvent('onPlayerDisconnect', 'doPlayerDisconnect');
$_PLUGIN->addEvent('onPlayerFinish', 'doPlayerFinish');
$_PLUGIN->addEvent('onPlayerManialinkPageAnswer', 'doHandleClick');
$_PLUGIN->addEvent('onGameModeChange', 'doGameModeChange');
$_PLUGIN->addEvent('onEndRound', 'doEndRound');
$_PLUGIN->addEvent('onStatusChangeTo3', 'doNewChallenge');

?>
