<?php
class Help extends Plugin {
  private $pages;
  private $openwindows;
  private $cmds_per_page = 10;

  function displayHelp($command)  {

    // create a window first ...
    $reopened = false;
    if ($this->existsPlayerData($command['author'], 'window')) {
      $window = $this->getPlayerData($command['author'], 'window');
      $window->maximize();
      $reopened = true;
    } else {
      $window = $this->createWindowToPlayerFramework('Aseco Help', 1.1, 0.55, $command['author']);
      $window->addCallback('close', 'closeHelp');
      $this->storePlayerData($command['author'], 'window', $window);
    }

    $i = 0;
    $a = 0;
    $messages = array();
    $message = '';
    foreach($this->Aseco->chat_commands as $chat_command) {
      foreach($chat_command as $sub_command) {
        // only display commands that can be executed by the player ...
        if (!$sub_command->is_admin || $this->Aseco->isAdmin($command['author']->login)) {

          $i++;
          $n++;

          // build page header ...
          if (($i % ($this->cmds_per_page)) == 1) {
            $message = '<line><cell width="0.8"><text halign="left">';
            $message .= '$333Currently supported Chat Commands:';
            $message .= '</text></cell></line>';
          }

          $message .= '<line>';
		  $message .= '<cell width="0.02"><text/></cell>';
          $message .= '<cell width="0.3"><text>$f00/'.$sub_command->name.'</text></cell>';
          $message .= '<cell width="0.8"><text>$000'.$sub_command->help.'</text></cell>';
          $message .= '</line>';

          // insert the page into the page array ...
          if (($i % ($this->cmds_per_page)) == 0) {
            $messages[] = $message;
            $n = 0;
          }
        }
      }
    }

    // insert the page into the page array ...
    if ($n > 0) {
      $messages[] = $message;
    }

    // set the message window content ...
    if (!$reopened)
      $window->setContent($messages);
  }

  function closeHelp($param, $window, $player) {
    $this->removePlayerData($player, 'window');
  }

  function showHelpToPlayer($player) {
    $this->displayHelp(array('author' => $player));
  }

  function init() {
    $statusbar = $this->Aseco->getPlugin('Statusbar');
    if ($statusbar) {
      $statusbar->addButton('Help', $this, 'showHelpToPlayer', 0.08);
    }
  }
}

$_PLUGIN = new Help();
$_PLUGIN->setAuthor('Florian Schnell');
$_PLUGIN->setVersion(1.0);
$_PLUGIN->addChatCommand('help', 'displayHelp', 'shows help');
$_PLUGIN->setDescription('Contains Chat Command listing functions. Displays all available Chat Commands on several pages.');
$_PLUGIN->addEvent('onSync', 'init');
?>
