<?php
class Plugins extends Plugin {
  private $openplugins;
  private $openplugininfos;
  
  function displayPlugins($command) {
    $plugins_per_page = 10;
    $pages = array();
    $page = 0;
    $i = 0;
    foreach($this->Aseco->plugins as $plugin) {
      if ($i == 0) {
        $message = '<line color="ffff"><cell bgcolor="cccf" width="0.35"><text halign="center">$000Name</text></cell><cell bgcolor="cccf" width="0.2"><text halign="center">$000Version</text></cell><cell bgcolor="cccf" width="0.35"><text halign="center">$000Author</text></cell></line>';
      }
      $message .= '<line><cell width="0.35"><text action="{name:plugininfo,param:'.$plugin->getName().'}" halign="center">$f00'.$plugin->getName().
      '</text></cell>';
      $message .= '<cell width="0.2"><text halign="center">$000'.$plugin->getVersion().
      '</text></cell>';
      $message .='<cell width="0.35"><text halign="center">$000'.$plugin->getAuthor().
      '</text></cell></line>';
      $i++;
      if ($i == $plugins_per_page ||
          $page * $plugins_per_page + $i == count($this->Aseco->plugins)) {
        $i = 0;
        $page++;
        $message .= '<line><cell><text>$333Click onto a plugin name to get additional information to it.</text></cell></line>';
        $pages[] = $message;
      }
    }
    
    // create window instance ...
    if ($this->existsPlayerData($command['author'], 'pluginswindow')) {
      $mp = $this->getPlayerData($command['author'], 'pluginswindow');
      $mp->maximize();
    } else {
      $mp = $this->createWindowToPlayerFramework('Plugins List', 0.45, 0.58, $command['author']);
      $mp->setWidth(0.9);
      $mp->setContent($pages);
      $mp->addCallback('plugininfo', 'displayPluginInfo');
      $mp->addCallback('close', 'closePlugins');
      $this->storePlayerData($command['author'], 'pluginswindow', $mp);
    }
  }
  
  function closePlugins($param, $window, $player) {
    $this->removePlayerData($player, 'pluginswindow');
  }
  
  function displayPluginInfo($param, $window, $player) {
    $plugin_name = $param;
    $plugin = $this->Aseco->getPlugin($plugin_name);
    if ($plugin != null) {
      $message = '<line><cell><text>$333Displaying information about the plugin '.$plugin_name.':'.LF.
                 '$f00Version: $000'.$plugin->getVersion().LF.
                 '$f00Author: $000'.$plugin->getAuthor().LF.
                 '$f00Description: $000'.$plugin->getDescription().LF.
                 '$f00Dependencies: $000';
      $dependencies = $plugin->getDependencies();
      if (count($dependencies) == 0) $message .= 'none';
      foreach($dependencies as $dependence) {
        $message .= $dependence->name;
        if (isset($dependence->min_ver)) $message .= ' min. '.$dependence->min_ver;
        if (isset($dependence->max_ver)) $message .= ' max. '.$dependence->max_ver;
        $message .= '; ';
      }
      if (strlen($plugin->getWebsite()) > 0)
        $message .= LF.'$f00Website: $000$l['.$plugin->getWebsite().']'.$plugin->getWebsite();
      $message .= '</text></cell></line>';
    } else {
      $message = '<line><cell><text>$000There\'s no plugin loaded called "'.$plugin_name.'"'.LF.
                 'Use the /plugins command to see which plugins are currently loaded</text></cell></line>';
    }
    
    // create window instance ...
    if ($this->existsPlayerData($player, 'infowindow')) {
      $mp = $this->getPlayerData($player, 'infowindow');
      $mp->setContent($message);
      $mp->maximize();
    } else {
      $mp = $this->createWindowToPlayerFramework($plugin_name.' - Plugin Info', 0.45, 0.4, $player);
      $mp->setWidth(0.9);
      $mp->setContent($message);
      $mp->addCallback('close', 'closePluginInfo');
      $this->storePlayerData($player, 'infowindow', $mp);
    }
  }
  
  function displayChatPluginInfo($command) {
    $this->displayPluginInfo($command['params'], null, $command['author']);
  }
  
  function closePluginInfo($param, $window, $player) {
    $this->removePlayerData($player, 'infowindow');
  }
}

$_PLUGIN = new Plugins();
$_PLUGIN->setAuthor('Florian Schnell');
$_PLUGIN->setVersion(1.0);
$_PLUGIN->addEvent('onPlayerServerMessageAnswer', 'pluginsCallback');
$_PLUGIN->addChatCommand('plugins', 'displayPlugins', 'displays a list of the currently loaded plugins');
$_PLUGIN->addChatCommand('plugin', 'displayChatPluginInfo', 'displays detailed information about a plugin.');
$_PLUGIN->setDescription('Displays informations about plugins.');
$_PLUGIN->setWebsite('http://www.tmbase.de');
?>