<?php
class Records extends Plugin {

  private $openwindows;
  private $records_to_show = 10;

  function displayRecords($command) {
    // create a window if there's not an open one already ...
    if ($this->existsPlayerData($command['author'], 'window')) {
      $window = $this->getPlayerData($command['author'], 'window');
      $window->maximize();
    } else {
      $window = $this->createWindowToPlayerFramework('Top '. $this->records_to_show .' Records on '.cutString(stripFormatting($this->Aseco->server->challenge->name), 23, stripFormatting($this->Aseco->server->challenge->name)), 0.9, 0.56, $command['author']);
      $window->addCallback('close', 'closeRecords'); // add close callback
      $this->storePlayerData($command['author'], 'window', $window);
    }

    // build the message string ...
    $message = '';
    $header = '<line><cell bgcolor="cccf" width="0.2"><text halign="center">$000Position</text></cell><cell bgcolor="cccf" width="0.4"><text halign="center">$000Player</text></cell><cell bgcolor="cccf" width="0.3"><text halign="center">$000';
    if ( $this->Aseco->server->gameinfo->getMode() == 'Stunts' ) {
      $header .= 'Score';
    } else {
      $header .= 'Time';
    }
    $header .= '</text></cell></line>';
    if ($this->Aseco->records->count() == 0) {
      $message .= '<line>';
      $message .= '<cell><text>$000Currently there are no records driven ...</text></cell>';
      $message .= '</line>';
    } else {
      for($i = 0; $i < $this->Aseco->records->count(); $i++) {
        $record = $this->Aseco->records->getRecord($i);
        if ($record->score == 0) break;
        $message .= '<line>';
        $message .= '<cell width="0.2"><text halign="center">$f00$o'.($i + 1).'</text></cell>';
        $message .= '<cell width="0.4"><text halign="center">$000' . htmlspecialchars(stripFormatting($record->player->nickname)) . '</text></cell>';
        if ( $this->Aseco->server->gameinfo->getMode() == 'Stunts' )
        {
          $s = $record->score;
        }
        else
        {
          $s = formatTime($record->score);
        }
        $message .= '<cell width="0.3"><text halign="center">$000'. $s .'</text></cell>';
        $message .= '</line>';
        if (($i + 1) % 10 == 0) {
          $messages[] = $header . $message;
          $message = '';
        }
      }
    }
    if ($message != '')
    $messages[] = $header . $message;

    // set the window's content ...
    $window->setContent($messages);
    $window->show();
  }

  function closeRecords($param, $window, $player) {
    $this->removePlayerData($player, 'window');
  }

  function showRecordsToPlayer($player) {
    $this->displayRecords(array('author' => $player));
  }

  function init() {
    $statusbar = $this->Aseco->getPlugin('Statusbar');
    if ($statusbar) {
      $statusbar->addButton('Records', $this, 'showRecordsToPlayer', 0.11);
    }
  }

  function setRecordsToShow($in_recs_to_show) {
    $this->records_to_show = $in_recs_to_show;
  }
}

$_PLUGIN = new Records();
$_PLUGIN->setAuthor('Florian Schnell');
$_PLUGIN->setVersion(1.0);
$_PLUGIN->addChatCommand('recs', 'displayRecords', 'shows top 5 records of the current map');
$_PLUGIN->addEvent('onSync', 'init');
?>
