<?php
class Score extends Plugin {
    function displayScore($command) {
    
    // get reference to the localdb plugin ...
    $localdb = $this->Aseco->getPlugin('LocalDb');
    $publicdb = $this->Aseco->getPlugin('PublicDb');
      
    // calculate average score of the current track for the local database ...
    if ($publicdb != null) {
      if ($publicdb->challenge['Votes'] && $publicdb->challenge['Score']) {
        $pdb_avg_score = $publicdb->challenge['Score']/$publicdb->challenge['Votes'];
      } else {
        $pdb_avg_score = 0;
      }
    }
    
    // calculate average score of the current track for the local database ...
    if ($localdb != null) {
      if ($localdb->challenge['Votes'] && $localdb->challenge['Score']) {
        $ldb_avg_score = $localdb->challenge['Score']/$localdb->challenge['Votes'];
      } else {
        $ldb_avg_score = 0;
      }
    }
    
    $message = '';
    
    // replace parameters ...
    if ($publicdb != null) {
      $message = formatText("{#interact}Current track has an average worldwide score of {#highlite}{1}",
                             $pdb_avg_score);
      // replace colors ...
      $message = $this->Aseco->formatColors($message);
  
      // send the message ...
      $this->sendServerMessageToLogin($command['author']->login, $message);
    }
    
    if ($localdb != null) {
      $message = formatText("{#interact}Current track has an average server score of {#highlite}{1}",
                             $ldb_avg_score);
      // replace colors ...
      $message = $this->Aseco->formatColors($message);
  
      // send the message ...
      $this->sendServerMessageToLogin($command['author']->login, $message);
    }
  }
}

$_PLUGIN = new Score();
$_PLUGIN->setAuthor('Florian Schnell');
$_PLUGIN->setVersion(1.0);
$_PLUGIN->addChatCommand('score', 'displayScore', 'displays the score of the current challenge');
$_PLUGIN->setDescription('Gets the score of a track from the database. A score is calculated from the votes that players sent for the track.');
?>