<?php
class Stats extends Plugin {
  function displayStats($command) {

    // decide whether to get information to the command author,
    // or to a specified player ...
    if ($command['params'] != '') {
      $player = $this->Aseco->server->players->getPlayer($command['params']);
    } else {
      $player = $command['author'];
    }

    // create window ...
    $window = $this->createWindowToPlayerFramework('Playerstats', 0.4, 0.4, $command['author']);

    // set window width ...
    $window->setWidth(0.8);

    if (isset($player)) {

      if ($this->Aseco->getPlugin('PublicDb') != null) {
        $dbplayer['Stats'] = $this->Aseco->getPlugin('PublicDb')->players[$player->login];
        $dbplayer['Name'] = 'Worldwide Statistics';
        $statsset[] = $dbplayer;
      }

      if ($this->Aseco->getPlugin('LocalDb') != null) {
        $dbplayer['Stats'] = $this->Aseco->getPlugin('LocalDb')->players[$player->login];
        $dbplayer['Name'] = 'Server Statistics';
        $statsset[] = $dbplayer;
      }

      $message = '';
      foreach ($statsset as $set) {

        // get player stats from the database(s) ...
        $wins = $set['Stats']['Wins'] + $player->getWins();
        $time_played = $set['Stats']['TimePlayed'] + $player->getTimeOnline();

        // build the message string ...
        $message .= '<line><cell width="0.8" bgcolor="000f"><text>$fffShowing '.$set['Name'].' of $s' . htmlspecialchars(stripFormatting($player->nickname)) . '</text></cell></line>';
        $message .= '<line><cell width="0.4"><text>$000Total Wins</text></cell><cell width="0.4"><text>$f00'.$wins.'</text></cell></line>';
        $message .= '<line><cell width="0.4"><text>$000Time Played</text></cell><cell width="0.4"><text>$f00'.formatTimeH($time_played.'000', false).'</text></cell></line>';
      }

    } else {

      // fault response ...
      $message = '<line><cell><text>$f00Notice: $000Player "'.$command['params'].'" is not online at the moment,'.LF.'or does not exist in the database!</text></cell></line>';
    }

    // set the window's content ...
    $window->setContent($message);
  }
}

$_PLUGIN = new Stats();
$_PLUGIN->setAuthor('Florian Schnell');
$_PLUGIN->setVersion(1.0);
$_PLUGIN->addChatCommand('stats', 'displayStats', 'shows statistics for a player');
$_PLUGIN->setDescription('Gets statistics of a specified player from the database and displays them.');
?>
