<?php
class Vote extends Plugin {
  function doVote($command) {
  
    // check if parameter is correct ...
    if (is_numeric($command['params']) && $command['params'] >= 0 && $command['params'] <= 10) {
      $score = $command['params'];
    } else {
    
      // replace colors ...
      $message = $this->Aseco->formatColors("{#error}You have to supply a numeric parameter (0-10)");
    
      // send the message ...
      $this->sendServerMessageToLogin($command['author']->login, $message);
      return;
    }
    
    $localok = true;
    $publicok = true;
    
    // make sure player hasn't voted already ...
    if ($this->Aseco->getPlugin('LocalDb') != null) {
      if (!$this->Aseco->getPlugin('LocalDb')->dbInsertVote($command)) {
        
        $localok = false;
        
        // replace colors ...
        $message = $this->Aseco->formatColors("{#error}you've voted locally for this track already");
    
        // send the message ...
        $this->sendServerMessageToLogin($command['author']->login, $message);
      }
    }
  
    // make sure player hasn't voted already ...
    if ($this->Aseco->getPlugin('PublicDb')) {
      if (!$this->Aseco->getPlugin('PublicDb')->dbInsertVote($command)) {
        
        $publicok = false;
        
        // replace colors ...
        $message = $this->Aseco->formatColors("{#error}You've set a global score fot this track already!");
    
        // send the message ...
        $this->sendServerMessageToLogin($command['author']->login, $message);
      }
    }
    
    // react on the vote ...
    if ($this->Aseco->getPlugin('LocalDb') != null && $localok) {
      $this->Aseco->getPlugin('LocalDb')->challenge['Score'] += $score;
      $this->Aseco->getPlugin('LocalDb')->challenge['Votes']++;
    }
    
    if ($this->Aseco->getPlugin('PublicDb') != null && $publicok) {
      $this->Aseco->getPlugin('PublicDb')->challenge['Score'] += $score;
      $this->Aseco->getPlugin('PublicDb')->challenge['Votes']++;
    }
  
    if ($publicok || $localok) {
      
      // replace parameters ...
      $message = formatText("{#interact}Your vote of ' {#highlite}{1}{#interact}' for this track has been saved!",
                          $score);
  
      // replace colors ...
      $message = $this->Aseco->formatColors($message);
  
      // send the message ...
      $this->sendServerMessageToLogin($command['author']->login, $message);
    }
  }
}

$_PLUGIN = new Vote();
$_PLUGIN->setAuthor('Florian Schnell');
$_PLUGIN->setVersion(1.0);
$_PLUGIN->addChatCommand('vote', 'doVote', 'votes for a track, requires parameter (0-10)');
$_PLUGIN->setDescription('Inserts a vote into the database which will generate a score for each track. Each player may only vote once per track.');
?>
