<?php

// Original version by Sloth/XXX.Max, via tm-forum.com
// Hack & Slash by AssemblerManiac

/* template file layout
   // header
   // {DATE} {TIME} {TRACK}
   // <!-- Player Data Begin ->  this tag not output to file
   // whatever is here gets duplicated for each person in the race, ranked 1-n, where n = <max_player_count> in the matchsave.xml file
   // {RANK} {NICK} {LOGIN} {TIME} {TEAM} {POINTS} are the reserved words
   // <!-- Player Data End ->	neither is this one
   // footer, tots for each team
   // <!-- Team Data Begin ->
   // {TEAM} {POINTS}
   // <!-- Team Data End ->
   // any remaining data will be written to the file from here to the end
 */

// if you want the teamname to show up properly when someone connects, make sure this plugin is AFTER the localdatabase plugin

class MatchSave2 extends Plugin
	{
	private $matchDebug = false;
	private $enabled = false;
	private $savedb = false;
	private $template;
	private $pointcount;
	private $points;
	private $savefile;
	private $format_date;
	private $format_time;
	private $outfile;
	private $outfilelast;

	private $matchOthersCanScore;
	private $matchTeamNameColorsAllowed;
	private $matchTeamNameMaxLength;
	private $teamForceTeams;
	private $matchAdminCommands;

	private $matchRound = -1;
	private $TotalRounds = -1;
	private $matchTime = -1;
	private $matchPointLimit = -1;
	private $matchRunning = false;
	private $matchPoints = array();
	private $matchAutoRestart = false;
	private $betweenChallenges = false;

	//////////////////////////////////////////////////
	function addMatchChatCommand($name, $description)
		{
		$this->matchAdminCommands[] = array($name, $description); // tack a new one on the end, auto numbered
		}      // end addMatchChatCommand

	function getArrayFirstIndex(&$arr)
		{
		if (!$arr)
			{
			return false;
			}

		foreach ($arr as $key => $value)
			return $key;
		} // end getArrayFirstIndex

	/**
	 * Show help
	 */
	function showMatchHelp(&$player)
		{
		$currentLeader='';

		if ($this->MatchRunning)
			{
			$runningMatch='Round ' . $this->col_window_highlite . $this->MatchRound;

			if ($this->TotalRounds != -1)
				$runningMatch .= ' ' . $this->col_window_default . 'of ' . $this->col_window_highlite . $this->TotalRounds;

			if ($this->matchPointLimit != -1)
				$runningMatch .= ' ' . $this->col_window_default . '- PL: ' . $this->col_window_highlite . $this->matchPointLimit;

			if ($this->matchAutoRestart)
				$runningMatch .= ' ' . $this->col_window_special . $this->col_window_default . '(' . $this->col_window_highlite . 'Auto' . $this->col_window_default . ')$z';

			$leader = $this->getArrayFirstIndex($this->matchPoints);

			if ($leader)
				{
				$leader = LF . $this->col_window_default . 'Leader: ' . $this->col_window_highlite . $leader . ' ' . $this->col_window_default . '(' . $this->col_window_highlite . $this->matchPoints[$leader] . $this->col_window_default . ')';
				}
			}
		else
			{
			$runningMatch = $this->col_window_highlite . 'None';
			}

		$matchStatus='$f00OFF';

		if ($this->enabled)
			$matchStatus='$0f0ON';

		$othersStatus='$f00OFF';

		if ($this->matchOthersCanScore)
			$othersStatus='$0f0ON';

		$forceStatus='$f00OFF';

		if ($this->teamForceEnabled)
			$forceStatus='$0f0ON';

		$tcStatus='$f00OFF';

		if ($this->teamchatEnabled)
			$tcStatus='$0f0ON';

		$help=$this->col_window_default . 'Matchsave MOD ' . $this->matchVersionNumber . ' by f*ckfish/Xymph/AM' . LF;
		$help .= $this->col_window_separator . '----------' . LF;
		$help .= $this->col_window_default . 'Plugin is: ' . $matchStatus . $this->col_window_separator . ' | ' . $this->col_window_default . 'Others score: ' . $othersStatus .
			$this->col_window_separator . ' | ' . $this->col_window_default . 'Force: ' . $forceStatus . $this->col_window_separator . ' | ' . $this->col_window_default . 'TC: ' . $tcStatus . $this->col_window_separator . LF;
		$help .= $this->col_window_default . 'Current match: ' . $runningMatch . $leader . LF;
		$help .= $this->col_window_separator . '----------' . LF;
		$help .= $this->col_window_default . 'Supported commands:' . LF;
		$help .= $this->col_window_hint . '(TIP: use ' . $this->col_window_default . '/admin match auto ' . $this->col_window_hint . 'instead of ' . $this->col_window_default . '/admin match start ' . $this->col_window_hint . 'to automate matches)$z' . LF;

		$padstg = $this->col_window_highlite . '... ';

		if (!empty($this->matchAdminCommands))
			{
			foreach ($this->matchAdminCommands as $chat_command)
				{
				$help .= $padstg . $chat_command[0] . ' ' . $this->col_window_default . $chat_command[1] . LF;
				}
			}

		if (strlen($help) < 1025)
			{
			$this->sendPopupWindowToPlayer($player->login, $help, "Match Help");
			}
		else
			{
			$help=substr($help, 0, 1024);
			$this->sendPopupWindowToPlayer($player->login, $help, "Match Help");
			$this->Aseco->client->query('ChatSendServerMessageToLogin', $this->Aseco->formatColors('{#error}Help message exceeded valid length, please contact f*ckfish via tm-forum.com.'), $player->login);
			}
		} // end showMatchHelp

	function matchDisplayStatus($msg)
		{
		$message=$this->col_chat_highlite . ">> " . $this->col_chat_plugin . "[Matchsave] " . $this->col_chat_default . $msg;
		$this->Aseco->client->query("ChatSendServerMessage", $this->Aseco->formatColors($message));
		} // end matchDisplayStatus

	function newChallenge(&$command)
		{
		$this->betweenChallenges=false;

		if ($this->enabled)
			{
			if ($this->MatchRunning)
				{
				if ($this->MatchRound == 1 && $this->startedBetweenChallenges)
					{
					$this->startedBetweenChallenges = false;
					}
				else
					{
					$this->MatchRound++;
					}

				$leader=$this->getArrayFirstIndex($this->matchPoints);

				if (($this->MatchRound > $this->TotalRounds && $this->TotalRounds != -1) || ($leader && $this->matchPointLimit != -1 && $this->matchPointLimit <= $this->matchPoints[$leader]))
					{
					$this->matchStop();
					}
				else
					{
					$autoText="";

					if ($this->matchAutoRestart)
						$autoText='Auto';

					$msg='Current ' . $autoText . 'Match: Round ' . $this->col_chat_highlite . $this->MatchRound . $this->col_chat_default;

					if ($this->TotalRounds != -1)
						{
						$msg .= ' of ' . $this->col_chat_highlite . $this->TotalRounds;
						}

					if ($this->matchPointLimit != -1)
						{
						$msg .= ' (Pointlimit ' . $this->col_chat_highlite . $this->matchPointLimit . $this->col_chat_default . ')';
						}

					$this->matchDisplayStatus($msg);
					}
				}
			}
		} // end match_newChallenge

	function matchGetCenteredLines(&$lines)
		{
		$maxlen=0;

		for ($i = 0; $i < count($lines); $i++)
			{
			$length = strlen(stripFormatting($lines[$i]));

			if ($length > $maxlen)
				$maxlen=$length;
			}

		for ($i = 0; $i < count($lines); $i++)
			{
			while (strlen(stripFormatting($lines[$i])) < $maxlen)
				{
				$lines[$i] = ' ' . $lines[$i] . ' ';
				}
			}

		return $lines;
		} // end matchGetCenteredLines

	function matchStart(&$admin, $numRounds, $pointLimit, $autoRestart)
		{
		if ($numRounds == -1)
			$numRounds='';

		if ($pointLimit == -1)
			$pointLimit='';

		$status='';
		$statustpl=array();
		$autoText="";

		if ($autoRestart)
			$autoText='Auto';

		$statustpl[]=$autoText . 'Match starts now!';
		$statustpl[]=$autoText . 'Match for ' . $this->col_chat_highlite . '{NUMROUNDS} ' . $this->col_chat_default . 'rounds starts now!';
		$statustpl[]=$autoText . 'Match starts now! Pointlimit is ' . $this->col_chat_highlite . '{POINTLIMIT}' . $this->col_chat_default . '.';

		if (!$this->MatchRunning)
			{
			$this->MatchRound=1;

			if ($numRounds)
				{
				if (is_numeric($numRounds))
					{
					$this->TotalRounds=$numRounds;
					$status=str_replace('{NUMROUNDS}', $numRounds, $statustpl[1]);
					}
				elseif ($numRounds == 'pl')
					{
					if ($pointLimit)
						{
						if (is_numeric($pointLimit))
							{
							$this->matchPointLimit=$pointLimit;
							$status=str_replace('{POINTLIMIT}', $pointLimit, $statustpl[2]);
							}
						else
							{
							if ($admin)
								$this->Aseco->client->query('ChatSendServerMessageToLogin', $this->Aseco->formatColors('{#error}{#message}' . $pointLimit . ' {#error}is not a number. Normal match started'), $admin->login);

							$status=$statustpl[0];
							}
						}
					else
						{
						if ($admin)
							$this->Aseco->client->query('ChatSendServerMessageToLogin', $this->Aseco->formatColors('{#error}You did not specify the pointlimit. Normal match started.'), $admin->login);

						$status=$statustpl[0];
						}
					}
				else
					{
					if ($admin)
						$this->Aseco->client->query('ChatSendServerMessageToLogin', $this->Aseco->formatColors('{#error}{#message}' . $numRounds . ' {#error}is not a number. Normal match started'), $admin->login);

					$status=$statustpl[0];
					}
				}
			else
				{
				$status = $statustpl[0];
				}

			$this->matchDisplayStatus($status);
			$this->MatchRunning=true;
			$this->matchPoints=array();
			$this->matchString="";
			$this->matchTime=time();
			$this->matchAutoRestart=$autoRestart;
			$this->startedBetweenChallenges=$this->betweenChallenges;
			}
		else
			{
			if ($admin)
				$this->Aseco->client->query('ChatSendServerMessageToLogin', $this->Aseco->formatColors('{#error}There is already a match running!'), $admin->login);
			}
		} // end matchStart

	function chatStandings(&$command)
		{
		$player=$command['author'];

		if ($this->MatchRunning)
			$this->showStandings('Current Match Standings', $player, 29);
		} // end chat_standings

	function chat_tc(&$command)
		{
		$author=$command['author'];
		$msg=$command['params'];
		$team=$author->teamname;

		if ($team)
			{
			if ($this->teamchatEnabled)
				{
				$msg=$this->Aseco->formatColors($this->teamchatPrefix . '$g$m [' . $author->nickname . '$g$m] ' . $msg);

				foreach ($this->Aseco->server->players->player_list as $player)
					{
					if ($player->teamname == $team || ($this->Aseco->isAdmin($player->login) && $this->bigBrother))
						{
						$this->Aseco->client->query("ChatSendServerMessageToLogin", $msg, $player->login);
						}
					}
				}
			else
				{
				$this->Aseco->client->query("ChatSendServerMessageToLogin", $this->Aseco->formatColors('{#error}Teamchat is currently disabled by an Admin.'), $author->login);
				}
			}
		else
			{
			$this->Aseco->client->query("ChatSendServerMessageToLogin", $this->Aseco->formatColors('{#error}You belong to no team; to join, type $fff/team yourteamname.'), $author->login);
			}
		} // end chat_tc

	function showStandings($headline, &$player, $separatorLength = 17)
		{
		$result[]=$this->col_window_default . $headline;
		$sep='';

		for ($i = 0; $i < $separatorLength; $i++)
			$sep .= '-';

		$result[]=$this->col_window_separator . $sep;

		if (!$player->teamname)
			$result[]=str_replace('{#server}', '$000', '$n' . $this->hlpNoTeam[0] . LF);

		$count=1;

		foreach ($this->matchPoints as $key => $value)
			if ($count <= 15)
				$result[]=$this->col_window_default . $count++ . '. ' . $this->col_window_highlite . $key . ' $z' . $this->col_window_default . '(' . $this->col_window_highlite . $value . $this->col_window_default . ')';

		$result=implode(LF, $result);
		$toReplace=$player->teamname;

		if (!$toReplace)
			$toReplace="OTHERS";

		$formattedMsg=$this->Aseco->formatColors(str_replace(' ' . $this->col_window_highlite . $toReplace . ' ', ' ' . $this->col_window_highlite_team . $toReplace . ' ', $result));

		$this->sendPopupWindowToPlayer($player->login, $formattedMsg, "Match Standings", $this->resultTimeout);
		} // end showStandings

	function matchStop($manually = false)
		{
		if ($this->enabled)
			{
			if ($manually)
				$this->matchAutoRestart=false;

			foreach ($this->Aseco->server->players->player_list as $player)
				$this->showStandings("Match Results", $player);

			$numRounds=$this->TotalRounds;
			$pointLimit=$this->matchPointLimit;

			if ($pointLimit > 0)
				$numRounds='pl';

			$autoRestart=$this->matchAutoRestart;

			$this->MatchRound=-1;
			$this->TotalRounds=-1;
			$this->matchPointLimit=-1;
			$this->matchPoints=array();
			$this->MatchRunning=false;
			$this->matchTime=-1;

			$fp=fopen($this->outfilematch, 'w');
			fwrite($fp, $this->matchString);
			fclose($fp);

			$autoText="";

			if ($this->matchAutoRestart)
				$autoText='Auto';

			$this->matchDisplayStatus($autoText . 'Match ended, scores saved.');

			if ($this->matchAutoRestart)
				{
				$this->matchStart(null, $numRounds, $pointLimit, $autoRestart);
				}
			}
		} // end matchStop


	// This is where all the Setting-Magic happens

	function chatMatch(&$command)
		{
		$admin=$command['author'];

		/* this is handled by the framework
				// check if chat command was used by an admin ...
				if (!$this->matchDebug)
					{
					if (!$this->Aseco->isAdmin($admin->login))
						{
						// writes warning in console ...
						$this->Aseco->console($admin->login . ' tried to use match chat command (no permission!)');

						// sends chat message ...
						$this->Aseco->client->query('ChatSendServerMessageToLogin', $this->Aseco->formatColors('{#error}You have to be in admin list to do that!'), $admin->login);
						return false;
						}
					}
		*/

		// split params into array
		$arglist=explode(' ', $command['params'], 2);
		$command['params']=explode(' ', $command['params']);

		$cmdcount=count($arglist);

		/**
		 * enable or disable the matchsave plugin
		 */
		if (strtolower($command['params'][0]) == "on" || strtolower($command['params'][0]) == "off")
			{
			$this->enabled=(strtolower($command['params'][0]) == "on");
			$this->matchDisplayStatus("Plugin is now " . $this->col_chat_highlite . strtoupper($command['params'][0]));
			}
		/**
		 * activate or de-activate the score tracking of teamless players
		 */
		elseif ($command['params'][0] == "others" && (strtolower($command['params'][1]) == "on" || strtolower($command['params'][1]) == "off"))
			{
			$this->matchOthersCanScore=(strtolower($command['params'][1]) == "on");
			$this->matchDisplayStatus("Players without team get scores: " . $this->col_chat_highlite . strtoupper($command['params'][1]));
			}
		/**
		 * activate or disactivate the score tracking of teamless players
		 */
		elseif ($command['params'][0] == "force" && $command['params'][1] != '')
			{
			$string=$command['params'][1];

			if ($string == "on" || $string == "off")
				{
				if ($string == "on")
					{
					$this->teamForceEnabled=true;
					$this->executeTeamForce();
					}
				else
					{
					$this->teamForceEnabled = false;
					}

				$this->matchDisplayStatus("Teamforce is now " . $this->col_chat_highlite . strtoupper($command['params'][1]));
				}
			else
				{
				foreach ($this->Aseco->server->players->player_list as $player)
					{
					if ($player->teamname == $this->defaultTeam)
						{
						$player->teamname=$string;
						$this->Aseco->client->query(
							'ChatSendServerMessageToLogin', $this->Aseco->formatColors($this->col_chat_highlite . '>' . $this->col_chat_plugin . ' Your Teamname was changed to ' . $this->col_chat_highlite . $string), $player->login);
						}
					else
						{
						$this->Aseco->client->query(
							'ChatSendServerMessageToLogin', $this->Aseco->formatColors($this->col_chat_highlite . '>' . $this->col_chat_plugin . ' Default Teamname is now ' . $this->col_chat_highlite . $string), $player->login);
						}
					}

				$this->defaultTeam=$string;
				}
			}
		/**
		 * activate or disactivate the teamchat
		 */
		elseif ($command['params'][0] == "tc" && $command['params'][1] != '')
			{
			$string=$command['params'][1];

			if ($string == "on" || $string == "off")
				{
				$this->teamchatEnabled=($string == "on");
				$this->matchDisplayStatus("Teamchat is now " . $this->col_chat_highlite . strtoupper($command['params'][1]));
				}
			}
		/**
		 * start a match (with our without a specified length)
		 */
		elseif ($command['params'][0] == "start" || $command['params'][0] == "auto")
			{
			$numRounds=$command['params'][1];
			$pointLimit=$command['params'][2];
			$autoRestart=false;

			if ($command['params'][0] == "auto")
				$autoRestart=true;

			$this->matchStart($admin, $numRounds, $pointLimit, $autoRestart);
			}
		/**
		 * stop or end a match and display the results
		 */
		elseif ($command['params'][0] == "end")
			{
			if ($this->MatchRunning)
				$this->matchStop(true);
			}
		/**
		 * load playlist txt file
		 */
		/* disabled because redundant with /admin readtracklist command - Xymph
			} elseif ($command['params'][0] == "load" && $command['params'][1] != "") {

				$filename = $command['params'][1];
				if (!strstr($filename, '.txt')) {
					$filename .= '.txt';
				}

				$filepath = $this->playlistDir . '/' . $filename;

				//CHECK IF FILE EXISTS
				//YES...
				if (file_exists($filepath)) {

					//CONSOLE MESSAGE ADD
					$this->Aseco->console("admin ".$command['author']->login." loads new Playlist: ".$filename);

					//SUCCESS MESSAGE
					$rtn = $this->Aseco->client->query('LoadMatchSettings', $filepath);
					if (!$rtn) {
						trigger_error('[' . $this->Aseco->client->getErrorCode() . '] ' . $this->Aseco->client->getErrorMessage(), E_USER_WARNING);
						$message = '{#server}> {#error}Error reading {#highlite}$i '.$filepath.' {#error}!';
					} else {
						$cnt = $this->Aseco->client->getResponse();
						$message = 'Successfully set new Playlist: '.$this->col_chat_highlite.$filename.$this->col_chat_default.' with '.$this->col_chat_highlite.$cnt.$this->col_chat_default.' tracks';
					}
					$this->Aseco->addCall('ChatSendServerMessageToLogin', array($this->Aseco->formatColors($message), $admin->login));

				//NO ...
				} else {
					//CONSOLE MESSAGE ADD
					$this->Aseco->console("admin ".$command['author']->login." tried to load unavailable Playlist.");

					//SENDS A FAILED MESSAGE
					$this->Aseco->addCall('ChatSendServerMessageToLogin', array($this->Aseco->formatColors('{#error}Playlist file unavailable'), $admin->login));
				}


			 // show a list of the available playlists
	// listing the playlists is also a redundant function, the /admin loadms function
			elseif ($command['params'][0] == 'list') {

				$dir = $this->playlistDir . '//';
				$tmp = array();
				$tmp = scandir($dir);
				$files = array();

				$search ='';
				if ($command['params'][1])
					$search = $command['params'][1];

				foreach ($tmp as $file) {
					if (stristr($file,'.txt'))
						$files[] = str_ireplace('.txt','',$file);
				}

				showPlaylistList($admin, $files, $search);
	*/
		/**
		 * Show Lists of teams and players
		 */
		elseif ($command['params'][0] == 'teams' || $command['params'][0] == 'players')
			{
			$search='';

			if ($command['params'][0] == 'players')
				$full=true;

			$this->showTeamList($admin, $full);
			}
		/**
		 * force player into a team
		 */
		elseif ($command['params'][0] == 'assign' && $command['params'][1] != '')
			{
			$victim=null;

			foreach ($this->Aseco->server->players->player_list as $player)
				if ($player->login == $command['params'][1])
					$victim=$player;

			if ($victim)
				{
				$victim->teamname=$command['params'][2];

				$msgend=' To change type "' . $this->col_chat_default . '/teamname yourteamname$fff$m" . ';
				$msgend=$this->Aseco->formatColors($msgend);
				$message='An Admin assigned <insert> to team ' . $this->col_chat_highlite . $victim->teamname . '$fff$m.';
				$message=$this->Aseco->formatColors($message);

				$message2='An Admin cleared <insert> teamname.';
				$message2=$this->Aseco->formatColors($message2);

				if ($victim->teamname)
					{
					foreach ($this->Aseco->server->players->player_list as $player)
						{
						if ($player->login == $victim->login)
							$msg=str_replace('<insert>', 'you', $message) . $msgend;
						else
							$msg=str_replace('<insert>', stripFormatting($victim->nickname), $message);

						$this->Aseco->client->query("ChatSendServerMessageToLogin", $msg, $player->login);
						}
					}
				else
					{
					foreach ($this->Aseco->server->players->player_list as $player)
						{
						if ($player->login == $victim->login)
							$msg=str_replace('<insert>', 'your', $message2) . $msgend;
						else
							$msg=str_replace('<insert>', stripFormatting($victim->nickname) . "'s", $message2);

						$this->Aseco->client->query("ChatSendServerMessageToLogin", $msg, $player->login);
						}
					}
				}
			else
				{
				$this->Aseco->client->query("ChatSendServerMessageToLogin", $this->Aseco->formatColors('{#error}' . $command['params'][1] . ' is not a valid login.'), $admin->login);
				}
			}
		/**
		 * display help
		 */
		else
			{
			$this->showMatchHelp($admin);
			}
		} // end chat_match

	function showListWindow(&$player, &$messageLines, $headline)
		{
		$msg='';
		$ctr=0;
		$ctr1=0;
		$lines=0;
		$msgs=array(); // clear out the message list before you do anything

		foreach ($messageLines as $msgline)
			{
			$msg .= '<line><cell><text>' . $msgline . '</text></cell></line>';

			$ctr1++;

			if ($ctr1 == 1)
				{
				$msg .= LF;
				$ctr1=0;
				$lines++;

				if ($lines > 9)
					{
					$msgs[]
						='<line><cell><text>'
						. $this->col_window_default . $headline . '</text></cell></line>' . '<line><cell><text>' . $this->col_window_separator . '---------------------' . $this->col_window_default . '</text></cell></line>' . $msg;
					$lines=0;
					$msg='';
					}
				}
			else
				{
				$msg .= ', ';
				}
			}

		if (strlen($msg) > 0)
			{
			if (substr($msg, -2, 2) == ', ')
				{
				$msg = substr($msg, 0, strlen($msg) - 2);
				}

			$msgs[]
				='<line><cell><text>'
				. $this->col_window_default . $headline . '</text></cell></line>' . '<line><cell><text>' . $this->col_window_separator . '---------------------' . $this->col_window_default . '</text></cell></line>' . $msg;
			//			$msgs[$ctr] = $this->col_window_default . $headline . LF .
			//				$this->col_window_separator . '---------------------' . $this->col_window_default . LF . $msg;
			}
		//print_r($msgs);

		if (count($msgs))
			{
			$w=$this->createWindowToPlayerFramework('Team Info', 1, 1, $player);
			$w->SetContent($msgs);
			}
		} // end showListWindow

	function showTeamList(&$player, $full)
		{
		$teams=array();
		$teamsMembers=array();

		foreach ($this->Aseco->server->players->player_list as $playa)
			{
			$teams[$playa->teamname]++;
			$teamsMembers[$playa->teamname][]=$playa;
			}

		arsort($teams);

		if (!$full)
			$header='Num .. Teamname';
		else
			$header='Team .. Nickname (Login)';

		$helper=array();

		foreach ($teams as $team => $members)
			{
			if (!$full)
				{
				$members=str_pad($members, 2, "0", STR_PAD_LEFT);

				if ($team == '')
					$team='OTHERS';

				$helper[]='$g$m   ' . $members . '    ' . $team;
				}
			else
				{
				$mbrs=$teamsMembers[$team];

				if ($team == '')
					$team='OTHERS';

				foreach ($mbrs as $mbr)
					$helper[]='$g$m' . $team . '$g$m    ' . $mbr->nickname . '$g$m   (' . $mbr->login . '$g$m)';
				}
			}

		$this->showListWindow($player, $helper, $header);
		} // end showTeamList

	/* unused function, see rasp_ms for a way to load a tracklist (match settings) file
		function showPlaylistList(&$player, &$files, &$search)
			{
			$helper = array();
			foreach ($files as $file)
				if (!$search || strstr($file, $search))
					$helper[] = $file;
	
			showListWindow($player, $helper, 'Available Playlists');
			}  // end showPlaylistList
	 */

	function executeTeamForce()
		{
		foreach ($this->Aseco->server->players->player_list as $player)
			{
			$team = $this->defaultTeam;

			if ($this->teamForceTeams[$player->login])
				$team=$this->teamForceTeams[$player->login];

			$player->teamname=$team;

			foreach ($this->Aseco->server->players->player_list as $recipient)
				{
				if ($recipient->login == $player->login)
					$msg
						=$this->col_chat_plugin . 'You have been auto-assigned to team '
						. $this->col_chat_highlite . $team . LF . $this->col_chat_default . 'Type ' . $this->col_chat_highlite . '/team yourteamname ' . $this->col_chat_default . 'to change your team.';
				else
					$msg=$this->col_chat_highlite . stripFormatting($player->nickname) . $this->col_chat_plugin . ' has been auto-assigned to team ' . $this->col_chat_highlite . $team;

				$this->Aseco->client->query("ChatSendServerMessageToLogin", $this->Aseco->formatColors($msg), $recipient->login);
				}
			}
		} // end executeTeamForce

	function playerConnect(&$player)
		{
		if ($this->teamForceEnabled)
			{
			$team=$this->defaultTeam;

			if ($this->teamForceTeams[$player->login])
				$team=$this->teamForceTeams[$player->login];

			$player->teamname=$team;

			foreach ($this->Aseco->server->players->player_list as $recipient)
				{
				if ($recipient->login == $player->login)
					$msg
						=$this->col_chat_plugin . 'You have been auto-assigned to team '
						. $this->col_chat_highlite . $team . LF . $this->col_chat_default . 'Type ' . $this->col_chat_highlite . '/team yourteamname ' . $this->col_chat_default . 'to change your team.';
				else
					$msg=$this->col_chat_highlite . stripFormatting($player->nickname) . $this->col_chat_plugin . ' has been auto-assigned to team ' . $this->col_chat_highlite . $team;

				$this->Aseco->client->query("ChatSendServerMessageToLogin", $this->Aseco->formatColors($msg), $recipient->login);
				}
			}
		else
			{
			if ($player->teamname == '')
				{
				$query='SELECT teamname FROM players WHERE Login=' . quotedString($player->login) . ' AND Game=' . quotedString($this->Aseco->server->getGame());
				$result=mysql_query($query);

				if (mysql_num_rows($result) > 0)
					$player->teamname=mysql_result($result, 0, "teamname");

				mysql_free_result($result);
				}
			}

		if ($this->enable && $player->teamname != '')
			{
			$this->Aseco->client->query(
				'ChatSendServerMessageToLogin', $this->Aseco->formatColors($this->col_chat_highlite . '>' . $this->col_chat_plugin . ' Your Team is currently ' . $this->col_chat_highlite . $player->teamname), $player->login);
			}
		} // end match_playerconnect

	function playerDisconnect(&$player)
		{
		if ($player->teamname != '')
			{
			$query='SELECT teamname FROM players WHERE Login=' . quotedString($player->login) . ' AND Game=' . quotedString($this->Aseco->server->getGame());
			$result=mysql_query($query);

			if (mysql_num_rows($result) > 0)
				{
				$teamname=mysql_result($result, 0, "teamname");

				if ($teamname == "")
					{
					$sql='UPDATE players SET teamname=' . quotedString($player->teamname) . ' WHERE login=' . quotedString($player->login);
					mysql_query($sql);
					}
				}
			}
		} // end match_playerdisconnect

	function startup()
		{
		$this->Aseco->client->query('ChatSendServerMessage', 'Now Loading Matchsave ffMod ' . $this->matchVersionNumber);
		$this->loadSettings();

		if ($this->savedb)
			{
			$this->checkTables();
			}

		$this->matchAdminCommands=array();

		$this->addMatchChatCommand("start", "start match");
		$this->addMatchChatCommand("start x", "start match for x rounds");
		$this->addMatchChatCommand("start pl x", "start match with pointlimit x");
		$this->addMatchChatCommand("end", "end match, write results");
		// disabled because redundant with /admin readtracklist command - Xymph
		//addMatchChatCommand("load x", 'load playlist x');
		$this->addMatchChatCommand("list x", 'shows playlist(s) x');
		$this->addMatchChatCommand("on/off", "plugin on/off");
		$this->addMatchChatCommand("others on/off", "teamless players score points");
		$this->addMatchChatCommand("force x", 'x=on/off: TeamForce on/off, x=random: set opponent name');
		$this->addMatchChatCommand("assign x y", 'force player with login x into team y');
		$this->addMatchChatCommand("teams", 'show teams ("/match players" shows teams and players)');
		$this->addMatchChatCommand("tc on/off", 'Teamchat on/off');
		} // end match_startup

	function chatTeamname(&$command)
		{
		$player=$command['author'];
		$teamname=$command['params'];

		$oldTeamName=$player->teamname;

		if ($teamname == 'help' || trim($teamname) == "")
			{
			if ($player->teamname)
				{
				$msg='Your currently belong to team ' . $this->col_window_highlite_team . $player->teamname . '$z' . LF;
				$msg .= str_replace('{#server}', '$000', '$n' . $this->hlp[0] . '$z' . LF);
				}
			else
				{
				$msg='You currently belong to no team.' . LF;
				$msg .= str_replace('{#server}', '$000', '$n' . $this->hlpNoTeam[0] . '$z' . LF);
				}

			$msg .= '$fff---------------------------------------$z' . CRLF;
			$msg .= 'Optional commands for /team (/teamname works too):' . CRLF;
			$msg .= '     $f00dbsave$z - save your teamname permanently on this server' . CRLF;
			$msg .= '     $f00dbclear$z - erase your permanent teamname from this server ' . CRLF;
			$msg .= '     $f00dbget$z - get your teamname for this server' . CRLF;
			$msg .= '     $f00clear$z - clear your current teamname' . CRLF;
			$msg .= '     $f00players$z - show a list of players in your team' . CRLF;
			$msg .= '$fff---------------------------------------' . CRLF;
			$msg .= '$000Use $f00/standings$000 to see current match standings.' . LF;
			$msg .= '$000Also use $f00/tc {#message}Hello Teammates $000 to chat only with your team.';

			if (!$this->teamchatEnabled)
				{
				$msg .= LF . $this->col_window_highlite . '     Currently disabled by an Admin';
				}

			$this->sendPopupWindowToPlayer($player->login, $this->Aseco->formatColors($msg), "Teamname Help");
			//			$this->Aseco->client->query('SendDisplayServerMessageToId', $player->id, $this->Aseco->formatColors($msg), 'OK', '', 0);
			}
		elseif ($teamname == 'clear')
			{
			$player->teamname='';
			$this->Aseco->client->query('ChatSendServerMessageToLogin', 'You are no longer a member of a team.', $player->login);
			}
		elseif ($teamname == 'players')
			{
			if ($player->teamname)
				{
				$helper=array();

				foreach ($this->Aseco->server->players->player_list as $playa)
					if ($playa->teamname == $player->teamname)
						$helper[]=$playa->nickname;

				sort($helper);
				$header='Team ' . $this->col_window_highlite_team . $player->teamname . '$z';
				$this->showListWindow($player, $helper, $header);
				}
			else
				{
				$this->Aseco->client->query("ChatSendServerMessageToLogin", $this->Aseco->formatColors('{#error}You belong to no team; to join, type $fff/team yourteamname.'), $author->login);
				}
			}
		elseif ($teamname == 'dbsave')
			{
			$sql='UPDATE players SET teamname=' . quotedString($player->teamname) . ' WHERE login=' . quotedString($player->login);
			mysql_query($sql);
			$this->Aseco->client->query('ChatSendServerMessageToLogin', 'Teamname saved to database.', $player->login);
			}
		elseif ($teamname == 'dbclear')
			{
			$sql="UPDATE players SET teamname='' WHERE login=" . quotedString($player->login);
			mysql_query($sql);
			$this->Aseco->client->query('ChatSendServerMessageToLogin', 'Teamname cleared from database.', $player->login);
			}
		elseif ($teamname == 'dbget')
			{
			$query='SELECT teamname FROM players WHERE Login=' . quotedString($player->login) . ' AND Game=' . quotedString($this->Aseco->server->getGame());
			$result=mysql_query($query);

			if (!$result)
				{
				$this->Aseco->client->query('ChatSendServerMessageToLogin', 'MySQL error = ' . mysql_error() . ', teamname not changed', $player->login);
				}
			else
				{
				$row=mysql_fetch_row($result);
				$player->teamname=$row[0];

				if (!$this->matchTeamNameColorsAllowed)
					$player->teamname=stripFormatting($player->teamname);

				$this->Aseco->client->query('ChatSendServerMessageToLogin', 'You have joined team ' . $player->teamname . '.', $player->login);
				mysql_free_result($result);
				}
			}
		else
			{
			if (!$this->matchTeamNameColorsAllowed)
				$teamname=stripFormatting($teamname);

			$teamname=substr($teamname, 0, $this->matchTeamNameMaxLength);

			$player->teamname=$teamname;
			$this->Aseco->client->query('ChatSendServerMessageToLogin', 'You have joined team ' . $player->teamname . '.', $player->login);
			}

		if ($this->showTeamChanges)
			{
			$newTeamName=$player->teamname;

			if ($newTeamName != $oldTeamName)
				foreach ($this->Aseco->server->players->player_list as $playa)
					if ($playa->login != $player->login)
						{
						if ($newTeamName == '')
							$msg=stripFormatting($player->nickname) . ' left team ' . $oldTeamName . '.';
						else
							$msg=stripFormatting($player->nickname) . ' joined team ' . $newTeamName;

						$this->Aseco->client->query("ChatSendServerMessageToLogin", $msg, $playa->login);
						}
			}
		} // end chat_teamname

	function endrace(&$info)
		{
		global $matchRunning, $matchRound, $matchTotalRounds, $matchPoints, $betweenChallenges, $MatchSettings, $matchOthersCanScore;

		$betweenChallenges=true;

		if (!$this->enable)
			return;

		$ranking=$info[0];

		if ($ranking[0]['Login'] == '')
			return;

		$TeamPoints=array();
		$challenge=$info[1];

		$db_challenge_id=$this->Aseco->getChallengeId($challenge['UId']);

		$sql='INSERT INTO match_main (trackID) VALUES (' . $db_challenge_id . ')';
		mysql_query($sql);
		$newID=mysql_insert_id();

		$template=$this->template;
		$stgout=str_replace('{HEADER}', '', $template['header']);

		if ($this->matchRound == 1)
			{
			$stgout=str_replace('{HEADER}', '<h2>Match - Started at ' . date($this->format_date, $this->matchTime) . ' - ' . date($this->format_time, $this->matchTime) . '</h2>', $template['header']);
			$this->matchString="";
			}

		$ctr=0;

		for ($i = 0; $i < $this->pointcount; $i++)
			{
			if ($ranking[$i]['Login'] > '')
				{
				$player=$this->Aseco->server->players->getPlayer($ranking[$i]['Login']);

				if ($player->teamname != '' || $this->matchOthersCanScore)
					{
					// if two people have the same time, they both get the same points
					if (($i > 0 && $ranking[$i]['BestTime'] != $ranking[$i - 1]['BestTime']))
						$ctr++;

					$rank=$ranking[$i]['Rank'];
					$bt=$ranking[$i]['BestTime'];

					if ($bt != -1)
						{
						$bt=formattime($bt);
						$pts=$this->points[$ctr];
						}
					else
						{
						$bt='DNF';
						$pts=0;
						}

					$TeamPoints[$player->teamname] += $pts;

					if ($this->savefile)
						{
						$nickname=stripFormatting($ranking[$i]['NickName']);
						// RANK, NICK, TIME, TEAM, POINTS are the substituted words for output
						$s=$template['detail'];
						$s=str_replace('{RANK}', $rank, $s);
						$s=str_replace('{NICK}', $nickname, $s);
						$s=str_replace('{TIME}', $bt, $s);
						$s=str_replace('{TEAM}', $player->teamname, $s);
						$s=str_replace('{POINTS}', $pts, $s);

						$stgout .= $s;
						}

					if ($this->savedb)
						{
						$sql='SELECT Id FROM players WHERE Login=' . quotedString($player->login) . ' AND Game=' . quotedString($this->Aseco->server->getGame());
						$result=mysql_query($sql);
						$db_player=mysql_fetch_array($result);
						$db_player_id=$db_player['Id'];
						mysql_free_result($result);
						$sql='INSERT INTO match_details (matchID, playerID, teamname, points, score) VALUES (' . $newID . ', ' . $db_player_id . ', ' . quotedString($player->teamname) . ', ' . $pts . ', ' . $ranking[$i]['BestTime'] . ')';
						mysql_query($sql);
						}
					}
				}
			}

		$matchcell='';

		if ($this->matchRunning)
			$matchcell='<th>This Match</th>';

		$stgout .= str_replace('{MATCHCELL}', $matchcell, $template['middle']);

		$tots='';
		$msg='';

		if ($this->matchRound == 1 || !$this->matchRunning)
			$this->matchPoints=array();

		$matchmsg="";

		foreach ($TeamPoints as $key => $value)
			{
			if ($key == '')
				$key='OTHERS';

			if ($value != 0)
				{
				if (!isset($this->matchPoints[$key]))
					$this->matchPoints[$key]=0;

				$this->matchPoints[$key] += $value;
				}
			}

		arsort($this->matchPoints, SORT_NUMERIC);

		foreach ($this->matchPoints as $key => $value)
			{
			$s = $template['teamdetail'];

			$matchmsg .= ' ' . $this->col_teamname_match . $key . ' $z' . $this->col_match_points . $value . ' ';

			$s=str_replace('{TEAM}', $key, $s);

			if ($key == 'OTHERS')
				$pts=$TeamPoints[''];
			else
				$pts=$TeamPoints[$key];

			if (!$pts)
				$pts=0;

			$s=str_replace('{POINTS}', $pts, $s);

			$matchpts="";

			if ($this->matchRunning)
				$matchpts='<td>' . $value . '</td>';

			$s=str_replace('{MATCHPOINTS}', $matchpts, $s);
			$stgout .= $s;

			$msg=$msg . ' ' . $this->col_teamname_round . $key . ' $z' . $this->col_round_points . $pts . ' ';
			}

		if ($this->savefile)
			{
			$stgout .= $template['footer'];
			$stgout=str_replace('{TRACK}', stripFormatting($challenge['Name']), $stgout);
			$stgout=str_replace('{DATE}', date($this->format_date, time()), $stgout);
			$stgout=str_replace('{TIME}', date($this->format_time, time()), $stgout);

			$fp=fopen($this->outfile, 'a');
			fwrite($fp, $stgout);
			fclose($fp);

			$fp=fopen($this->outfilelast, 'w');
			fwrite($fp, $stgout);
			fclose($fp);

			$this->matchString .= $stgout;
			}

		$noFinishRace=false;

		if ($msg == '')
			{
			$noFinishRace=true;
			$msg='$z' . $this->col_round_points . 'Noone in a team finished.';
			}

		$noFinishMatch=false;

		if ($matchmsg == '')
			{
			$noFinishMatch=true;
			$matchmsg='$z' . $this->col_match_points . 'Noone in a team finished';
			}

		foreach ($this->Aseco->server->players->player_list as $player)
			{
			$toReplace = $player->teamname;

			if (!$toReplace)
				$toReplace="OTHERS";

			if (!$noFinishRace)
				$formattedMsg=str_replace(' ' . $this->col_teamname_round . $toReplace . ' ', ' ' . $this->col_teamname_round_highlite . $toReplace . ' ', $msg);
			else
				$formattedMsg=$msg;

			if (!$noFinishMatch)
				$formattedMatchMsg=str_replace(' ' . $this->col_teamname_match . $toReplace . ' ', ' ' . $this->col_teamname_match_highlite . $toReplace . ' ', $matchmsg);
			else
				$formattedMatchMsg=$matchmsg;

			$formattedMsg=$this->Aseco->formatColors($this->str_round . '$z  ' . $formattedMsg);
			$formattedMatchMsg=$this->Aseco->formatColors($this->str_match . '$z  ' . $formattedMatchMsg);

			$this->Aseco->client->query('ChatSendServerMessageToLogin', $formattedMsg, $player->login);

			if ($matchRunning)
				$this->Aseco->client->query('ChatSendServerMessageToLogin', $formattedMatchMsg, $player->login);

			$this->showHint($player);
			}
		} // end endrace

	function showHint(&$player)
		{
		if ($this->helpEnabled)
			{
			if ($player->teamname)
				{
				$array=$this->hlp;
				$array[]=$array[0];
				$firstprob=5;
				$prob=10;
				}
			else
				{
				$array=$this->hlpNoTeam;
				$firstprob=2;
				$prob=4;
				}

			srand(microtime() * 1000000);
			$showhint=rand(1, 10);

			if ($showhint > $firstprob)
				{
				$hint='';
				srand(microtime() * 100000);
				$showmainhint=(rand(1, 10)) > $prob;

				if ($showmainhint)
					{
					$hint = $array[0];
					}
				else
					{
					srand(microtime() * 10000000);
					$hint=$array[rand(1, count($array) - 1)];
					}

				$this->Aseco->client->query('ChatSendServerMessageToLogin', $this->Aseco->formatColors('[Hint] ' . $hint), $player->login);
				}
			}
		} // end showHint


	//////////////////////////////////
	/*
		function playerconnect(&$player)
			{
			if ( $this->enabled )
				{
				$cmd['author'] = $player;
				$cmd['params'] = 'dbget';
				$this->chatTeamName($cmd);
				}
			}  //  match_playerconnect
	
		function startup()
			{
			$this->Aseco->client->query('ChatSendServerMessage', 'Now Loading Match Plugin v1.0');
			$this->match_loadsettings();
			if ( $this->savedb == 1)
				{
				$this->checkTables();
				}
			}  //  match_startup
	
		function chatTeamname(&$command)
			{
			$player = $command['author'];
			$teamname = trim($command['params']);
	
			if ( substr($teamname,0,2) == 'db' )
				{
				$db_player_id = $this->Aseco->plugins['LocalDb']->dbGetPlayerId($player);
				}
	
			if ( $teamname == 'help' )
				{
				$msg = 'Optional commands for /teamname are:' . CRLF;
				$msg .= '   $f00clear$z - clear your current teamname' . CRLF;
				$msg .= '   $f00dbsave$z - save your teamname permanently on this server' . CRLF;
				$msg .= '   $f00dbclear$z - erase your permanent teamname from this server ' . CRLF;
				$msg .= '   $f00dbget$z - get your teamname for this server';
				$this->sendPopupWindowToPlayer($player->login, $msg, "/teamname Help");
				}
			elseif ( $teamname == 'clear' )
				{
				$player->teamname = '';
				$this->Aseco->client->query('ChatSendServerMessageToLogin', 'You are no longer a member of a team.', $player->login);
				}
			elseif ( $teamname == 'dbsave' )
				{
				$sql = 'update players set teamname=' . quotedString($player->teamname) . '
					WHERE id=' . $db_player_id;
	//			WHERE Login=' . quotedString(stripLogin($player->login)) . ' AND Game=' . quotedString($this->Aseco->server->getGame());
				mysql_query($sql);
	
				$this->Aseco->client->query('ChatSendServerMessageToLogin', 'Teamname saved to database.', $player->login);
				}
			elseif ( $teamname == 'dbclear' )
				{
				$sql = 'update players set teamname=\'\'
					WHERE id=' . $db_player_id;
	//			WHERE Login=' . quotedString(stripLogin($player->login)) . ' AND Game=' . quotedString($this->Aseco->server->getGame());
				mysql_query($sql);
				$this->Aseco->client->query('ChatSendServerMessageToLogin', 'Teamname cleared from database.', $player->login);
				}
			elseif ( $teamname == 'dbget' )
				{
				$query = 'SELECT teamname FROM players
					WHERE id=' . $db_player_id;
	//				WHERE Login=' . quotedString(stripLogin($player->login)) . ' AND Game=' . quotedString($this->Aseco->server->getGame());
				$result = mysql_query($query);
				if ( !$result )
					{
					$this->Aseco->client->query('ChatSendServerMessageToLogin', 'MySQL error = ' . mysql_error() . ', teamname not changed', $player->login);
					}
				else
					{
					$row = mysql_fetch_row($result);
					if ( strlen($row[0]) == 0 )
						{
						$this->Aseco->client->query('ChatSendServerMessageToLogin', 'No teamname saved in database, teamname not changed.', $player->login);
						}
					else
						{
						$player->teamname = $row[0];
						$this->Aseco->client->query('ChatSendServerMessageToLogin', 'You have joined team ' . $player->teamname, $player->login);
						}
					mysql_free_result($result);
					}
				}
			elseif ( $teamname == '' && strlen($player->teamname) > 0)
				{
				$this->Aseco->client->query('ChatSendServerMessageToLogin', 'You are currently on team ' . $player->teamname, $player->login);
				}
			elseif ( $teamname == '' && strlen($player->teamname) == 0)
				{
				$this->Aseco->client->query('ChatSendServerMessageToLogin', 'You are not currently on a team', $player->login);
				}
			else
				{
				$player->teamname = $teamname;
				$this->Aseco->client->query('ChatSendServerMessageToLogin', 'You have joined team ' . $player->teamname, $player->login);
				}
	
			}  //  chat_teamname
	
		function showHint(&$player)
			{
			if ($this->helpEnabled)
				{
				if ($player->teamname)
					{
					$array = $this->hlp;
					$array[] = $array[0];
					$firstprob = 5;
					$prob = 10;
					}
				else
					{
					$array = $this->hlpNoTeam;
					$firstprob = 2;
					$prob = 4;
					}
	
				srand(microtime()*1000000);
				$showhint = rand(1,10);
				if ($showhint > $firstprob)
					{
					$hint='';
					srand(microtime()*100000);
					$showmainhint = (rand(1,10)) > $prob;
					if ($showmainhint)
						{
						$hint = $array[0];
						}
					else
						{
						srand(microtime()*10000000);
						$hint = $array[rand(1,count($array)-1)];
						}
					$this->Aseco->client->query('ChatSendServerMessageToLogin', $this->Aseco->formatColors('[Hint] '.$hint), $player->login);
					}
				}
			}  // end showHint
	
		function match_endrace(&$info)
			{
			if ( $this->enabled == false )
				{
				return;
				}
	
			$ranking = $info[0];
			if($ranking[0]['Login'] == '')
				{
				return;
				}
	
			$TeamPoints = array();
			$challenge = $info[1];
	
			$db_challenge_id = $this->getChallengeId($challenge['UId']);
	
			$sql = 'insert into match_main (trackID) values (' . $db_challenge_id . ')';
			mysql_query($sql);
			$newID = mysql_insert_id();
	
			$template = $this->template;
			$stgout = $template['header'];
	
			$ctr = 0;
			for($i = 0;$i < $this->pointcount; $i++)
				{
				if ( $ranking[$i]['Login'] > '' )
					{
					if ( ($i > 0 && $ranking[$i]['BestTime'] != $ranking[$i - 1]['BestTime']))		// if two people have the same time, they both get the same points
						{
						$ctr++;
						}
					$player = $this->Aseco->server->players->getPlayer($ranking[$i]['Login']);
	
					$rank = $ranking[$i]['Rank'];
					$bt = $ranking[$i]['BestTime'];
					if ( $bt != -1 )
						{
						if ( $this->Aseco->server->gameinfo->getMode() != 'Stunts' )
							{
							$bt = formattime($bt);
							}
						$pts = $this->points[$ctr];
						}
					else
						{
						$bt = 'DNF';
						$pts = 0;
						}
	
					$TeamPoints[$player->teamname] += $pts;
	
					if ( $this->savefile == 1 )
						{
						$nickname = stripFormatting($ranking[$i]['NickName']);
						// RANK, NICK, TIME, TEAM, POINTS are the substituted words for output
						$s = $template['detail'];
						$s = str_replace('{RANK}', $rank, $s);
						$s = str_replace('{NICK}', $nickname, $s);
						$s = str_replace('{TIME}', $bt, $s);
						$s = str_replace('{TEAM}', $player->teamname, $s);
						$s = str_replace('{POINTS}', $pts, $s);
	
						$stgout .= $s;
						}
	
					if ( $this->savedb == 1 )
						{
						$db_player_id = $this->Aseco->plugins['LocalDb']->dbGetPlayerId($player);
	//					$sql = 'select Id from players
	//					where Login=' . quotedString(stripLogin($player->login)) . ' AND Game=' . quotedString($this->Aseco->server->getGame());
	//					$result = mysql_query($sql);
	//					$db_player = mysql_fetch_array($result);
	//					$db_player_id = $db_player['Id'];
	//					mysql_free_result($result);
						$sql = 'insert into match_details (matchID, playerID, teamname, points, score) values (' . $newID . ', ' . $db_player_id . ', ' . quotedString($player->teamname) . ', ' . $pts . ', ' . $ranking[$i]['BestTime'] . ')';
						mysql_query($sql);
						}
					}
				}
	
			$stgout .= $template['middle'];
	
			$tots = '';
			$msg = '';
			foreach($TeamPoints as $key => $value)
				{
				$s = $template['teamdetail'];
				if ( $key == '' )
					{
					$key = 'OTHERS';
					}
				$s = str_replace('{TEAM}', $key, $s);
				$s = str_replace('{POINTS}', $value, $s);
				$stgout .= $s;
				$msg = $msg . '$F00' . $key . '$z {#highlite}' . $value . '  ';
				}
	
			if ( $this->savefile == 1 )
				{
				$stgout .= $template['footer'];
				$stgout = str_replace('{TRACK}', stripFormatting($challenge['Name']), $stgout);
				$stgout = str_replace('{DATE}', date($this->format_date, time()), $stgout);
				$stgout = str_replace('{TIME}', date($this->format_time, time()), $stgout);
	
				$fp = fopen($this->outfile, 'a');
				if ( $fp )
					{
					fwrite($fp, $stgout);
					fclose($fp);
					}
	
				$fp = fopen($this->outfilelast, 'w');
				if ( $fp )
					{
					fwrite($fp, $stgout);
					fclose($fp);
					}
				}
	
			$msg = $this->Aseco->formatColors('$i$F00Points This Round$z  ' . $msg);
			$this->Aseco->client->query('ChatSendServerMessage', $msg);
			}
	
		function chatAdmin($command)
			{
			$admin = $command['author'];
			if ( $command['params'] == 'begin' )
				{
				$msg = '{#server}>> Admin has started the match';
				$this->Aseco->client->query('ChatSendServerMessage', $this->Aseco->formatColors($msg));
				$this->match_loadsettings();
				$this->enabled = true;
				}
			elseif ( $command['params'] == 'end' )
				{
				$this->enabled = false;
				$msg = '{#server}>> Admin has ended the match';
				$this->Aseco->client->query('ChatSendServerMessage', $this->Aseco->formatColors($msg));
				}
			else
				{
				$msg = '{#server}>> Match is currently ';
				if ( $this->enabled )
					$msg .= 'Running';
				else
					$msg .= 'Stopped';
				$this->Aseco->client->query('ChatSendServerMessageToLogin', $this->Aseco->formatColors($msg), $admin->login);
				}
			}  //  chatadmin
	*/
	function loadSettings()
		{
		$settings=$this->Aseco->xml_parser->parseXML('settings/matchsave.xml');
		$settings=$settings['MATCHSAVE_SETTINGS'];
		$this->savedb=strtolower($settings['SAVE_TO_DB'][0]) == 'true';
		$this->savefile=strtolower($settings['SAVE_TO_FILE'][0]) == 'true';
		$this->template=$settings['TEMPLATE_NAME'][0];
		$this->outfile=$settings['OUTPUT_NAME'][0];
		$this->outfilelast=$settings['OUTPUT_NAME_LAST'][0];
		$this->outfilematch=$settings['OUTPUT_NAME_MATCH'][0];
		$this->pointcount=$settings['MAX_PLAYER_COUNT'][0];
		$this->format_date=$settings['FORMAT_DATE'][0];
		$this->format_time=$settings['FORMAT_TIME'][0];
		$this->enabled=strtolower($settings['ENABLED'][0]) == 'true';
		$this->teamForceEnabled=strtolower($settings['TEAM_FORCE_ENABLED'][0]) == 'true';
		$this->teamchatEnabled=strtolower($settings['TEAMCHAT_ENABLED'][0]) == 'true';
		$this->helpEnabled=strtolower($settings['HELP_ENABLED'][0]) == 'true';
		$this->str_round=$settings['STR_POINTS_THIS_ROUND'][0];
		$this->str_match=$settings['STR_POINTS_THIS_MATCH'][0];
		$this->col_round_points=$settings['COL_ROUND_POINTS'][0];
		$this->col_match_points=$settings['COL_MATCH_POINTS'][0];
		$this->col_teamname_round=$settings['COL_TEAMNAME_ROUND'][0];
		$this->col_teamname_round_highlite=$settings['COL_TEAMNAME_ROUND_HIGHLITE'][0];
		$this->col_teamname_match=$settings['COL_TEAMNAME_MATCH'][0];
		$this->col_teamname_match_highlite=$settings['COL_TEAMNAME_MATCH_HIGHLITE'][0];
		$this->col_chat_plugin=$settings['COL_CHAT_PLUGIN'][0];
		$this->col_chat_default=$settings['COL_CHAT_DEFAULT'][0];
		$this->col_chat_highlite=$settings['COL_CHAT_HIGHLITE'][0];
		$this->col_window_default=$settings['COL_WINDOW_DEFAULT'][0];
		$this->col_window_highlite=$settings['COL_WINDOW_HIGHLITE'][0];
		$this->col_window_highlite_team=$settings['COL_WINDOW_HIGHLITE_TEAM'][0];
		$this->col_window_special=$settings['COL_WINDOW_SPECIAL'][0];
		$this->col_window_separator=$settings['COL_WINDOW_SEPARATOR'][0];
		$this->col_window_hint=$settings['COL_WINDOW_HINT'][0];
		$this->teamchatPrefix=$settings['TEAMCHAT_PREFIX'][0];
		$this->resultTimeout=$settings['MATCH_RESULTS_TIMEOUT'][0];
		$this->bigBrother=strtolower($settings['ADMIN_CAN_READ_TEAMCHAT'][0]) == 'true';
		$this->showTeamChanges=strtolower($settings['SHOW_TEAMNAME_CHANGES_TO_PUBLIC'][0]) == 'true';
		$this->matchOthersCanScore=strtolower($settings['OTHERS_CAN_SCORE'][0]) == 'true';
		$this->matchTeamNameMaxLength=intval($settings['TEAMNAME_MAX_LENGTH'][0]);
		$this->matchTeamNameColorsAllowed=strtolower($settings['TEAMNAME_COLORS_ALLOWED'][0]) == 'true';
		$this->matchRound=-1;
		$this->matchTotalRounds=-1;
		$this->matchTime=-1;
		$this->matchPointLimit=-1;
		$this->matchRunning=false;
		$this->matchPoints=array();
		$this->matchAutoRestart=false;
		$this->betweenChallenges=false;

		$this->hlpNoTeam=array();
		$this->hlpNoTeam[]=$settings['HLP_NO_TEAM'][0];

		foreach ($settings['HLP_RANDOM_MSG_NO_TEAM'] as $hlp)
			{
			$this->hlpNoTeam[] = $hlp;
			}

		$this->hlp=array();
		$this->hlp[]=$settings['HLP_CHANGE_TEAM'][0];

		foreach ($settings['HLP_RANDOM_MSG'] as $hlp)
			{
			$this->hlp[] = $hlp;
			}

		//Team Force addition
		$this->defaultTeam=$settings['TEAMFORCE_TEAMS'][0]['DEFAULT_TEAM_NAME'][0];

		if ($settings['TEAMFORCE_TEAMS'][0]['TEAM'])
			{
			foreach ($settings['TEAMFORCE_TEAMS'][0]['TEAM'] as $index => $team)
				{
				if ($team['NAME'][0] && $team['LOGINS'][0]['LOGIN'])
					{
					foreach ($team['LOGINS'][0]['LOGIN'] as $login)
						{
						$this->teamForceTeams[$login] = $team['NAME'][0];
						}
					}
				}
			}

		$s=$settings['POINTS'][0];
		$s=str_replace(' ', '', $s);
		$this->matchPoints=explode(',', $s);

		foreach ($this->matchPoints as $key => $value)
			{
			$this->matchPoints[$key] = intval($value);
			}

		$this->points=$this->matchPoints;
		$MatchOutput=array();

		if (!$this->savefile)
			{
			return;
			}

		$fp=fopen($this->template, 'r');
		$data=fread($fp, 32767);                       // get whole template
		fclose($fp);
		$i=strpos($data, '<!-- Player Data Begin ->'); // strlen = 25
		$j=strpos($data, '<!-- Player Data End ->');   // strlen = 23
		$k=strpos($data, '<!-- Team Data Begin ->');   // strlen = 23
		$l=strpos($data, '<!-- Team Data End ->');     // strlen = 21
		$header=substr($data, 0, $i);                  // strpos returns 0 based, no adj to $i necessary
		$detail=substr($data, $i + 25, $j - ($i + 26) + 1);
		$middle=substr($data, $j + 23, $k - ($j + 24) + 1);

		$teamdetail=substr($data, $k + 23, $l - ($k + 24) + 1);
		$footer=substr($data, $l + 21);

		$MatchOutput['header']=$header;
		$MatchOutput['detail']=$detail;
		$MatchOutput['middle']=$middle;
		$MatchOutput['teamdetail']=$teamdetail;
		$MatchOutput['footer']=$footer;

		$this->template=$MatchOutput;

		// features to add once rasp tmu is upgraded with new aseco framework (these will be much easier to implement)
		// /admin match begin # - run the match for # tracks
		// /admin team login teamname - move a player to a particular team
		// /match scores - popup window with team scores for most recent match, may have way to show details per team

		} //  loadSettings

	function checkTables()
		{
		$check[1]=false;
		$check[2]=false;

		$query='CREATE TABLE IF NOT EXISTS `match_main` (
					  `ID` mediumint(9) NOT NULL auto_increment,
					  `trackID` mediumint(9) NOT NULL default 0,
					  `dttmrun` timestamp NOT NULL default Now(),
					  PRIMARY KEY	(`ID`)
					  ) TYPE=MyISAM Default Character Set UTF8';
		$result2=mysql_query($query);

		$query='CREATE TABLE IF NOT EXISTS `match_details` (
					  `matchID` mediumint(9) not null,
					  `playerID` mediumint(9) NOT NULL default 0,
					  `teamname` varchar(40),
					  `points` tinyint default 0,
					  `score` mediumint(9),
					  PRIMARY KEY (`matchID`,`playerID`)
					  ) TYPE=MyISAM Default Character Set UTF8';
		$result3=mysql_query($query);

		$res=mysql_query('show tables');

		while ($row = mysql_fetch_row($res))
			{
			$tables[] = $row[0];
			}

		if (in_array('match_main', $tables))
			{
			$check[1] = true;
			}

		if (in_array('match_details', $tables))
			{
			$check[2] = true;
			}

		mysql_free_result($res);

		$res=mysql_query('select teamname from players limit 1');

		if ($res == false)
			{
			if (mysql_errno() == 1054)
				{
				mysql_query('alter table players add TeamName char(60)');
				}
			}
		else
			{
			mysql_free_result($res);
			}

		if ($check[1] && $check[2])
			{
			return true;
			}
		else
			{
			return false;
			}
		}

	function getChallengeId($uid)
		{
		$query='SELECT Id FROM challenges WHERE Uid=\'' . mysql_real_escape_string($uid) . '\'';
		$res=mysql_query($query);

		if (mysql_num_rows($res) > 0)
			{
			$row=mysql_fetch_row($res);
			$rtnval=$row[0];
			}
		else
			{
			$rtnval = 0;
			}

		mysql_free_result($res);
		return $rtnval;
		}
	}

$_PLUGIN=new MatchSave2();
$_PLUGIN->setAuthor('Assembler Maniac');
$_PLUGIN->setVersion(2.2);
$_PLUGIN->addDependence('LocalDb', 1.0, null);
$_PLUGIN->addEvent('onStartup', 'startup'); // init vars, load settings
$_PLUGIN->addEvent('onEndRace', 'endrace');
$_PLUGIN->addEvent('onPlayerConnect', 'playerConnect');
$_PLUGIN->addEvent('onPlayerDisconnect', 'playerDisconnect');
$_PLUGIN->addEvent('onNewChallenge', 'newChallenge');
$_PLUGIN->addChatCommand('admin match', 'chatMatch', 'begin/end a match', 'matchadmin');
$_PLUGIN->addChatCommand('teamname', 'chatTeamname', 'Set your team name OR help for more options');
$_PLUGIN->addChatCommand('team', 'chatTeamname', 'Set your team name OR help for more options');
$_PLUGIN->addChatCommand('tc', 'chat_tc', 'Send a chat message to your team only.');
$_PLUGIN->addChatCommand('standings', 'chatStandings', 'See current match standings');
$_PLUGIN->setDescription('Save Match results as HTML/DB/text');

/*
/tc sent a message...no one saw it.

If you want me to I'll send you the logs. but you should be able to see for yourself now.
I hope this helps.

*/
?>
