<?php

/*
select `name`, sum(score) as Scr from rs_karma, challenges
where challenges.id=rs_karma.challengeid
group by `name`
order by scr
*/

/* repopulate the records table with best times - won't work for stunts
truncate table records;
insert into records(ChallengeId, PlayerId, Score, `Date`)
select challenges.id, Playerid, min(Score), from_unixtime(rs_times.`Date`) from challenges, rs_times
where rs_times.trackid=challenges.id group by challenges.id, playerid;

select * from records r where score not in
(select score from rs_times rs
where trackid=challengeid and rs.playerid=r.playerid);

*/

class Rasp extends Plugin {
	var $feature_ranks = false;
	var $feature_stats = false;
	var $maxrecs = 5;
	var $minrank = 0;
	var $maxavg = 0;
	var $ranks;
	var $settings;
	var $challenges;
	var $responses;
	var $maxrec;
	var $playerlist;
	var $messages;
	var $version = "2.3.2";
	var $besttime;
	var $pbshown = false;			// should normally happen on newtrack, but if admin restarts, it doesn't always trigger

	// formatScore - time or score from wherever (score is on stunts mode, time for all other types)
	// helper function, return score formatted as time or number depending on current server mode
	function formatScore($score)
		{
		if ( $this->Aseco->server->gameinfo->getMode() == 'Stunts' )
			return $score;
		else
			return formatTime($score);
		}  //  formatScore

	function onStartup()
		{
		$this->Aseco->console_text('[rasp] Cleaning up unused data');
		$sql = 'DELETE FROM challenges where uid=\'\'';
		mysql_query($sql);
		$sql = 'DELETE FROM players where login=\'\'';
		mysql_query($sql);
		$sql = 'DELETE FROM records where not exists (select id from players p where p.id=records.PlayerId)';
		mysql_query($sql);
		$sql = 'DELETE FROM records where not exists (select id from challenges c where c.id=records.ChallengeId)';
		mysql_query($sql);
		$sql = 'DELETE FROM rs_times where not exists (select id from players p where p.id=rs_times.playerID)';
		mysql_query($sql);
		$sql = 'DELETE FROM rs_times where not exists (select id from challenges c where c.id=rs_times.trackID)';
		mysql_query($sql);

		$this->Aseco->console_text('*-*-*-*-*-* RASP TMU ' . $this->version . ' is running! *-*-*-*-*-*');
		$this->Aseco->console_text('|...Loading Settings');
		$settings = $this->Aseco->xml_parser->parseXML('settings/rasp.xml');
		if ( !$settings )
			{
			$this->Aseco->console_text('{RASP_ERROR} - Config file parse error! (rasp.xml)');
			return;
			}
		$settings = $settings['SETTINGS']['RASP'][0];
		$this->messages = $settings['MESSAGES'][0];
		foreach ($this->messages as $key => $value)
			{
			unset($this->messages[$key]);
			$this->messages[$key] = $value[0];
			}
		$this->maxrecs = $settings['MAXRECS'][0];
		$this->minrank = $settings['MINRANK'][0];
		$this->maxavg = $settings['MAXAVG'][0];
		$this->feature_ranks = $settings['FEATURE_RANKS'][0] == '1' ? 1 : 0;
		$this->feature_stats = $settings['FEATURE_STATS'][0] == '1' ? 1 : 0;
		$this->Aseco->console_text('|...Loaded!');
		$this->Aseco->console_text('|...Checking database structure');
		if($this->checkTables() == false)
			{
			$this->Aseco->console_text('{RASP_ERROR} - Table structure incorrect. If you\'ve seen this message more than one time, there may be a problem with your database. Go to tm-forum.com (toolbox) and ask for some help.');
			return;
			}
		$this->Aseco->console_text('|...Structure OK!');

		$this->getChallenges();

		$this->resetRanks();
		}

	function onSync()
		{
		$this->Aseco->records->setLimit($this->maxrecs);
		}  //  onSync

	function checkTables()
		{
		$check[1] = false;
		$check[2] = false;
		$check[3] = false;

		$query = 'CREATE TABLE IF NOT EXISTS `rs_karma` (
								`Id` int(11) NOT NULL auto_increment,
								`Score` smallint(6) NOT NULL default 0,
								`PlayerId` mediumint(9) NOT NULL default 0,
								`ChallengeId` mediumint(9) NOT NULL default 0,
								PRIMARY KEY (`Id`),
								UNIQUE KEY `PlayerId` (`PlayerId`,`ChallengeId`),
								KEY `ChallengeId` (`ChallengeId`)
								) TYPE=MyISAM;';
		$result = mysql_query($query);

		$query = 'CREATE TABLE IF NOT EXISTS `rs_times` (
								`ID` mediumint(9) NOT NULL auto_increment,
								`playerID` mediumint(9) NOT NULL default 0,
								`trackID` mediumint(9) NOT NULL default 0,
								`score` mediumint(9) NOT NULL default 0,
								`date` int(10) unsigned NOT NULL default 0,
								PRIMARY KEY	(`ID`)
							) TYPE=MyISAM Default Character Set UTF8';
		$result2 = mysql_query($query);

		$query = 'CREATE TABLE IF NOT EXISTS `rs_rank` (
								`playerID` mediumint(9) NOT NULL default 0,
								`avg` float NOT NULL default 0,
								KEY `playerID` (`playerID`)
							) TYPE=MyISAM Default Character Set UTF8';
		$result3 = mysql_query($query);

		$res = mysql_query('show tables');
		while ($row = mysql_fetch_row($res)){ $tables[] = $row[0]; }

		if (in_array('rs_rank', $tables)) { $check[1] = true; }
		if (in_array('rs_times', $tables)) { $check[2] = true; }
		if (in_array('rs_karma', $tables)) { $check[3] = true; }

		mysql_free_result($res);

		$res = mysql_query('show create table rs_times');
		$row = mysql_fetch_row($res);
		if ( stripos($row[1], 'rs_times_player_track') == 0)
			{
			mysql_query('create index rs_times_player_track on rs_times (playerID, trackID)');
			}
		mysql_free_result($res);

		if ($check[1] && $check[2] && $check[3])
			{
			return true;
			}
		else
			{
			return false;
			}
		}

	function getChallenges() {
		$i = 0;
		while (!$done)
			{
			$this->Aseco->client->query('GetChallengeList', 300, $i);
			$response = $this->Aseco->client->getResponse();
			$tlist = array();
			if (sizeof($response) > 0)
				{
				if ( isset($response['faultString']) )
					{
					$done = true;
					$this->Aseco->client->error->code = 0;
					$this->Aseco->client->error->message = '';
					break;
					}
				foreach ($response as $trow)
					{
					$newlist[] = $trow;
					}
				if ( sizeof($response) < 300 )
					{
					$done = true;
					break;
					}
				else
					{
					$i = $i + 300;
					}
				}
			else
				{
				$done = true;
				break;
				}
			}

		foreach ($newlist as $row)
			{
			$query = 'SELECT * FROM challenges WHERE Uid=\'' . mysql_real_escape_string($row['UId']) . '\'';
			$res = mysql_query($query);
			if (!mysql_num_rows($res) > 0) {
				$query = 'INSERT INTO challenges
							(Uid, Name, Author, Environment)
							VALUES
							(\'' . mysql_real_escape_string($row['UId']) . '\', \'' . mysql_real_escape_string($row['Name']) . '\', \'' . mysql_real_escape_string($row['Author']) . '\', \'' . $row['Environnement'] . '\')';
				$res2 = mysql_query($query);
			}
			$tlist[] = $this->getChallengeId($row['UId']);
			mysql_free_result($res);

		}
		$this->challenges = $tlist;
	}

	function resetRanks() {
		$players = array();
		$this->Aseco->console_text('|...Calculating ranks');
		$this->getChallenges();

		$cleartable = 'DELETE FROM rs_rank';
		mysql_query($cleartable);
		$tracks = $this->challenges;
		$query = 'SELECT PlayerId, COUNT( * ) AS cnt
					FROM records
					GROUP BY PlayerId
					HAVING cnt >' . $this->minrank;
		$res = mysql_query($query);
		while ($row = mysql_fetch_object($res)) {
			$players[] = $row->PlayerId;
		}
		mysql_free_result($res);

		foreach ($tracks as $track) {
			$rank = array();
			$query = 'SELECT PlayerId
						FROM records
						WHERE ChallengeId=\'' . $track . '\'
						ORDER BY Score ASC,`Date` ASC';		// added Date sorting, will force results to be consistent with person who got the score first staying first
			$res = mysql_query($query);
			$i = 1;
			if (mysql_num_rows($res) == 0) {
				$trank[$track] = array();
			} else {
				while ($row = mysql_fetch_object($res)) {
					$pid = $row->PlayerId;
					$trank[$track][$pid] = $i;
					$i++;
				}
			}
			mysql_free_result($res);
		}

		foreach ($players as $player) {
			$exists = false;
			$query = 'SELECT playerID FROM rs_rank WHERE playerID=\'' . $player . '\'';
			$res = mysql_query($query);
			if (mysql_num_rows($res) > 0){
				$exists = true;
			}
			$rank = array();
			foreach ($tracks as $cur) {
				if (array_key_exists($player, $trank[$cur])) {
					if ($trank[$cur][$player] > $this->maxrecs) {
						$rank[$cur] = $this->maxrecs;
					} else {
						$rank[$cur] = $trank[$cur][$player];
					}
				} else {
					$rank[$cur] = $this->maxrecs;
				}
			}
			$avg = array_sum($rank) / sizeof($tracks);
			$avg = floor(round($avg, 4)*10000);		// Mistral says this fixes the bouncing bug (older mysql doesn't handle floats quite right)
			if ($exists == true) {
				$query = 'UPDATE rs_rank SET avg=' . $avg . ' WHERE playerID=\'' . $player . '\'';
				$res2 = mysql_query($query);
			} else {
				$query = 'INSERT INTO rs_rank(playerID, avg) VALUES (\'' . $player . '\', ' . $avg . ')';
				$res2 = mysql_query($query);
				if (mysql_affected_rows() != 1) {
					$errmsg = 'Tried to insert player : ' . $player . ' with average : ' . $avg . ' -FAILED!';
					$this->Aseco->console_text($errmsg);
				}
			}
			mysql_free_result($res);
		}
	$this->Aseco->console_text('|...Done!');
	}

	function onPlayerjoin(&$player)
		{
		if ($this->feature_ranks == true) { $this->showRank($player); }
		if ($this->feature_stats == true)
			{
			if ( isset($this->Aseco->server->challenge->data['DB_ID']) )
				{
				$this->showPb($player, $this->Aseco->server->challenge->data['DB_ID']);
				}
			}
		}

	function makePbWinContent($data)
		{
	//print_r($data); echo CRLF;
		$content = "<line height='.035'>
					<cell width='.04'><text halign='right' textcolor='eee'>Rec:</text></cell>
					<cell width='.09'><text textcolor='eee'> " . $this->formatScore($this->besttime) . "</text></cell></line>
					<line height='.030'>
					<cell width='.04'><text halign='right' textcolor='eee'>PB:</text></cell>
					<cell width='.09'><text textcolor='eee'> " . $data . "</text></cell></line>
					<line height='.030'>
					<cell width='.041'><text halign='right' textcolor='eee'>Avg:</text></cell>
					<cell width='.09'><text textcolor='eee'> Above</text></cell></line>
					<line height='.030'>
					<cell width='.053'><text halign='right' textcolor='eee'>Rank:</text></cell>
					<cell width='.09'><text textcolor='eee'> Sorta</text></cell></line>";
		return $content;
		}  //  setPbWinData

	function showPb(&$player, $track) {
		$found = false;
		for ($i = 0; $i < $this->maxrecs; $i++) {
			$rec = $this->Aseco->records->getRecord($i);
			if ($rec->player->login == $player->login) {
				$ret['time'] = $rec->score;
				$ret['rank'] = $i + 1;
				$found = true;
				break;
			}
		}
		$pid = $this->Aseco->plugins['LocalDb']->dbGetPlayerId($player);

		if ($found == false) {
			$query2 = 'SELECT score FROM rs_times WHERE playerID=' . $pid . ' and trackID=' . $track . ' ORDER BY score ASC LIMIT 1';
			$res2 = mysql_query($query2);
			if (mysql_num_rows($res2) > 0) {
				$row = mysql_fetch_array($res2);
				$ret['time'] = $row['score'];
				$ret['rank'] = '{#highlite}UNRANKED';
				$found = true;
			}
			mysql_free_result($res2);
		}

		$query = 'SELECT score FROM rs_times WHERE playerID=' . $pid . ' and trackID=' . $track . ' ORDER BY date DESC LIMIT 10';
		$res = mysql_query($query);
		$size = mysql_num_rows($res);
		if ($size > 0)
			{
			$total = 0;
			while ($row = mysql_fetch_object($res))
				{
				$total = $total + $row->score;
				}
			$avg = $this->formatScore(floor($total / $size));
			}
		else
			{
			$avg = 'Nope';
			}
		mysql_free_result($res);

		if ($found == true) {
			$message = formatText($this->messages['PB'],
	 			$this->formatScore($ret['time']),
				$ret['rank'],
				$avg);
			$content = $this->makePbWinContent($this->formatScore($ret['time']));
			$message = $this->Aseco->formatColors($message);
			$this->sendServerMessageToLogin($player->login, $message);
		} else {
			$message = formatText($this->messages['PB_NONE']);
			$message = $this->Aseco->formatColors($message);
			$this->sendServerMessageToLogin($player->login, $message);
			$content = $this->makePbWinContent('None');
			unset($ret['time']);
		}

	if ( isset($player->data['w_pb']) )
		{
		$window = $player->data['w_pb'];
		$window->setContent($content);
		$window->show();
		}
	else
		{
    	$window = $this->createWindowToPlayerFramework('', 1, 0.450, $player, true);
//		$window->makeStatic();
		$window->setContent($content);
		$window->setBackground('2224');
		$window->setBorderSize(0);
		$window->setTextsize(1);
		$window->show();
		$player->data['w_pb'] = $window;
		}

	if ( isset($ret['time'] ) )
		{
		$player->data['pb'] = $ret['time'];
		}
	else
		{
		$player->data['pb'] = 0;
		}
	}

	function showRank($player) {
		$mode = $this->Aseco->server->gameinfo->getMode();
		$pid = $this->Aseco->plugins['LocalDb']->dbGetPlayerId($player);
		$query = 'SELECT avg FROM rs_rank WHERE playerID=' . $pid . ' ORDER BY avg ASC';
		$res = mysql_query($query);
		if (mysql_num_rows($res) > 0) {
			$row = mysql_fetch_array($res);
			$query2 = 'SELECT * FROM rs_rank WHERE avg>0 and avg <' . $row['avg'];
			$res2 = mysql_query($query2);
			$query3 = 'SELECT * FROM rs_rank';
			$res3 = mysql_query($query3);
			$message = formatText($this->messages['RANK'],
				mysql_num_rows($res2)+1,
				mysql_num_rows($res3),
				round($row['avg']/10000, 1));
			$message = $this->Aseco->formatColors($message);
			$this->sendServerMessageToLogin($player->login, $message);
			mysql_free_result($res2);
			mysql_free_result($res3);
		} else {
			$message = formatText($this->messages['RANK_NONE'], $this->minrank);
			$message = $this->Aseco->formatColors($message);
			$this->sendServerMessageToLogin($player->login, $message);
		}
		mysql_free_result($res);
	}

	function onFinish(&$finish_item)
		{
		$mode = $this->Aseco->server->gameinfo->getMode();
		$player = $this->Aseco->server->players->getPlayer($finish_item->player->login);
		if ( $finish_item->score == 0 ) return;
		if ($this->feature_stats) {
			// update personal best if it's a new high
			$player = $player;
			$finish_time = $this->formatScore($finish_item->score);
			if (($mode != 'Stunts' && $finish_item->score < $player->data['pb']) ||
				($mode == 'Stunts' && $finish_item->score > $player->data['pb']) ||
				($player->data['pb'] == 0))
				{
				$content = $this->makePbWinContent($finish_time);
				// 9-9-07 AM - jaypsi has seen problems where an aseco restart can cause problems here, added the if to keep it from blowing up trying to use object that isn't set
				if ( isset($player->data['w_pb']) )
					{
					$player->data['w_pb']->setContent($content);
					}
				$player->data['pb'] = $finish_item->score;
				}
			$this->insertTime($finish_item);
			for ($i = 0; $i < $this->maxrecs; $i++)
				{
				$cur_record = $this->Aseco->records->getRecord($i);
				if ((($mode != 'Stunts' && $finish_item->score < $cur_record->score) ||
					 ($mode == 'Stunts' && $finish_item->score > $cur_record->score) ||
					!isset($cur_record) ||
					(($finish_item->player->login == $cur_record->player->login) && 		// might be current player got new best time
					 ($i == 0) &&
					 ($finish_item->score == $cur_record->score))) &&
					$finish_item->score > 0)
					{
					if ( $i == 0 )
						{
						// this is a new best time for the track
						// update the track rec display (rec/pb data) for each player
						$this->besttime = $finish_item->score;
						foreach($this->Aseco->server->players->player_list as $pl)
							{
							$content = $this->makePbWinContent($this->formatScore($pl->data['pb']));
							$pl->data['w_pb']->setContent($content);
							}
						}
					$cur_rank = -1;
					for ($rank = 0; $rank < $this->Aseco->records->count(); $rank++) {
						$rec = $this->Aseco->records->getRecord($rank);
						if ($rec->player->login == $player->login)
							{
							if (($mode == 'Stunts' && $rec->score >= $finish_item->score) ||
								($mode != 'Stunts' && $rec->score <= $finish_item->score))
								{
								return;
								}
							else
								{
								$cur_rank = $rank;
								}
							}
						}
					if ($cur_rank != -1)
						{
						if ($cur_rank > $i)
							{
							if ($i > 4)
								{
								$message = formatText($this->messages['NEW_RANK'], $finish_time, $i+1);
								$message = $this->Aseco->formatColors($message);
								$this->sendServerMessageToLogin($player->login, $message);
								}
							}
						else
							{
							if ($i > 4)
								{
								$message = formatText($this->Aseco->chat_messages['RECORD_NEW'], $i+1, $finish_time);
								$message = $this->Aseco->formatColors($message);
								$this->sendServerMessageToLogin($player->login, $message);
								}
							}
						}
					else
						{
						if ($i > 4)
							{
							$message = formatText($this->messages['NEW_RANK'], $finish_time, $i+1);
							$message = $this->Aseco->formatColors($message);
							$this->sendServerMessageToLogin($player->login, $message);
							}
						}
					return;
					}
				}
			}
		}

	function onNewtrack(&$challenge)
		{
		if ($this->feature_stats == true && !$this->pbshown)
			{
			$this->besttime = $this->Aseco->records->getRecord(0)->score;
			if ( !isset($challenge->data['DB_ID']) )
				{
				$challenge->data['DB_ID'] = $this->getChallengeId($challenge->uid);
				}

			foreach($this->Aseco->server->players->player_list as $pl)
				{
				$this->showPb($pl, $challenge->data['DB_ID']);
				}
			$this->pbshown = true;
			}
		}

	function onStatus4($info)
		{
		$this->onNewTrack($this->Aseco->server->challenge);
		}  //  onStatus4

	function onStatus5($info)
		{
		$this->pbshown = false;
		}  //  onStatus5

	function insertTime($timedata)
		{
		$pid = $this->Aseco->plugins['LocalDb']->dbGetPlayerId($timedata->player);
		$query = 'INSERT INTO rs_times (playerID, trackID, score, date) VALUES (' . $pid . ', ' . $timedata->challenge->data['DB_ID'] . ', ' . $timedata->score . ', ' . time() . ')';
		$res = mysql_query($query);
		if (mysql_affected_rows() != 1)
			{
			$this->Aseco->console('[RASP Error] Could not insert time! sql=' . $query);
	 		}
		}

	function onEndRace(&$challenge)
		{
		if ($this->feature_ranks == true)
			{
			$this->resetRanks();
			foreach($this->Aseco->server->players->player_list as $pl)
				{
				$this->showRank($pl);
				$pl->data['w_pb']->hide();
				}
			}
		}

	function getChallengeId($uid) {
		$query = 'SELECT Id FROM challenges WHERE Uid=\'' . mysql_real_escape_string($uid) . '\'';
		$res = mysql_query($query);
		if (mysql_num_rows($res) > 0) {
			$row = mysql_fetch_row($res);
			$rtnval = $row[0];
		} else {
			$rtnval = 0;
		}
		mysql_free_result($res);
		return $rtnval;
	}

	function chat_raspver(&$command)
		{
		$verinfo = '{#server}PHP: {#highlite}' . phpversion() . '{#server}, mySQL: {#highlite}' . mysql_get_server_info() . '{#server}, RASP: {#highlite}' . $this->version;
		$this->Aseco->client->query('ChatSendServerMessageToLogin', $this->Aseco->formatColors($verinfo), $command['author']->login);
		}  //  chat_raspver

	//chat functions..
	function chat_pb(&$command){
		if ($this->feature_stats == true) {
			$this->showPb($command['author'], $this->Aseco->server->challenge->data['DB_ID']);
		}
	}

	function chat_rank(&$command){
		if ($this->feature_ranks == true) {
			$this->showRank($command['author']);
		}
	}

	function chat_top5(&$command)
		{
		$query = 'SELECT p.NickName, r.avg FROM players p LEFT JOIN rs_rank r ON (p.Id=r.PlayerId) WHERE r.avg!=0 ORDER BY r.avg ASC LIMIT 5';
		$res = mysql_query($query);
		$i = 1;
		$content = "<line height='.04'>
	<cell width='0.06' bgcolor='888E'><text></text></cell>
	<cell width='0.78' bgcolor='888E'><text>  Name</text></cell>
	<cell width='0.10' bgcolor='888E'><text>Rank</text></cell></line>";
		$top = 5;
		while ($row = mysql_fetch_object($res)) {
			$content .= CRLF . "<line><cell width='0.06'><text halign='right'>" . $i . ".</text></cell><cell width='0.78'><text>  " . htmlspecialchars($row->NickName) . "</text></cell><cell width='0.10'><text>" . round($row->avg/10000, 1) . "</text></cell></line>" . CRLF;
			$i++;
		}
		mysql_free_result($res);
    	$window = $this->createWindowToPlayerFramework('Top 5 Players', 0.94, 0.325, $command['author']);
		$window->setContent($content);
//		$window->setWidth(0.94);
		}

	function cancelvote()
		{
		$this->Aseco->client->query('CancelVote');
		$this->sendServerMessage($this->Aseco->formatColors($this->messages['CANCELVOTE']));
		}  //  cancelvote

	function endround(&$command)
		{
		if ( $this->Aseco->server->gameinfo->getMode() == 'Rounds' )
			{
			$this->Aseco->client->query('ForceEndRound');
			$this->sendServerMessage($this->Aseco->formatColors($this->messages['ENDROUND']));
			}
		else
			{
			$this->sendServerMessageToLogin($command['author']->login, $this->Aseco->formatColors($this->messages['ENDROUNDERR']));
			}
		}  //  cancelvote

	function chat_seen(&$command)
		{
		$player = $command['author'];
		$command['params'] = explode(' ', $command['params']);
		$wildcard = $command['params'][0];
		$wildcard = quotedString($wildcard);
		if ( $wildcard == '' || !isset($wildcard) )
			{
			$msg = ">> You need to give at least a partial login name.";
			$this->sendServerMessageToLogin($player->login, $msg);
			return;
			}

		$query = "select nickname, login, updatedat from players where game='TMU' and locate($wildcard, login) > 0 order by login";
		$res = mysql_query($query);

		$ctr = 0;
		$page = 0;
		$header = "<line height='.04'>
	<cell width='0.50' bgcolor='888E'><text>Name</text></cell>
	<cell width='0.3' bgcolor='888E'><text halign='center'>Login</text></cell>
	<cell width='0.24' bgcolor='888E'><text halign='center'>Last Seen</text></cell></line>";

		$content = array();
		while ($row = mysql_fetch_object($res)) {
			$stgout = "<line height='.03'><cell width='0.50'><text>" . htmlspecialchars($row->nickname) . ".</text></cell><cell width='0.3'><text halign='center'>  " . stripFormatting($row->login) . "</text></cell><cell width='0.24'><text halign='center'>" . $row->updatedat . "</text></cell></line>" . CRLF;
			if ( !isset($content[$page]) )
				{
				$content[$page] = $header;
				}
			$content[$page] .= $stgout;
			$ctr++;
			if ( $ctr >= 12 )
				{
				$ctr = 0;
				$page++;
				}
		}
		mysql_free_result($res);
    	$window = $this->createWindowToPlayerFramework('Player Sightings', 1.04, 0.325, $command['author']);
		$window->setTextsize(1.2);
		$window->setContent($content);
//		$window->setWidth(1.04);

		}  //  chat_seen
	}

$_PLUGIN = new Rasp();
$_PLUGIN->setAuthor('Assembler Maniac');
$_PLUGIN->setVersion(2.3);
$_PLUGIN->addDependence('LocalDb', 1.0, null);
$_PLUGIN->setDescription('Server Ranking');
$_PLUGIN->addEvent('onStartup', 'onStartup');
$_PLUGIN->addEvent('onPlayerFinish', 'onFinish');
$_PLUGIN->addEvent('onNewChallenge', 'onNewtrack');
$_PLUGIN->addEvent('onEndRace', 'onEndRace');
$_PLUGIN->addEvent('onPlayerConnect', 'onPlayerJoin');
$_PLUGIN->addEvent('onStatusChangeTo4', 'onStatus4');
$_PLUGIN->addEvent('onStatusChangeTo5', 'onStatus5');
$_PLUGIN->addEvent('onSync', 'onSync');
$_PLUGIN->addChatCommand('pb', 'chat_pb', 'Displays your personal best on the current track');
$_PLUGIN->addChatCommand('rank', 'chat_rank', 'Displays your current server rank');
$_PLUGIN->addChatCommand('top5', 'chat_top5', 'Displays the top 5 ranked players');
$_PLUGIN->addChatCommand('raspver', 'chat_raspver', 'Display php/mysql/aseco/rasp version info');
$_PLUGIN->addChatCommand('admin cancelvote', 'cancelvote', 'Cancel the vote (TMU) in progress', 'cancelvote');
$_PLUGIN->addChatCommand('admin endround', 'endround', 'Force the end of the current round', 'endround');
$_PLUGIN->addChatCommand('seen', 'chat_seen', 'When was a player last on? (/seen {partial login})');
?>
