<?php

/* plugin.rasp_chatbot.php

 Original idea (and some text) from XXX.Max, many other contributors have had hands in this.

 Provides for ban/kick/msgs from the bot
 edit chatbot.xml to change words/phrases/general settings

 */

class ChatBot extends Plugin
	{
	private $BotTag;
	private $kickwords;
	private $kicktext;
	private $banwords;
	private $bantext;
	private $blacklistwords;
	private $blacklisttext;
	private $textmsgs;

	function loadSettings()
		{
		$settings = $this->Aseco->xml_parser->parseXML('settings/chatbot.xml');
		$settings = $settings['SETTINGS'];

		foreach ($settings as $key => $value)
			{
			if ( $key == 'WATCHFOR' )
				{
				continue;
				}
			unset($settings[$key]);
			$settings[$key] = $value[0];
			}

		$this->textmsgs = array();

		foreach ($settings['WATCHFOR'][0]['TEXT'] as $val)
			{
			$t1 = split('\|', $val);
			$key = $t1[0];
			unset($t1[0]);
			$this->textmsgs[$key] = $t1;
			}

		$this->BotTag = $settings['BOTTAG'];
		$this->kicktext = $settings['KICKTEXT'];
		$this->bantext = $settings['BANTEXT'];
		$this->kickwords = split(',', $settings['KICKWORDS']);
		$this->banwords = split(',', $settings['BANWORDS']);
		$this->blacklistwords = split(',', $settings['BLACKLISTWORDS']);
		}

	function checkChatText(&$command)
		{
		// ignore text that comes from the server
		// also ignore anything that looks like it's a command
		if ( $command[0] == 0 || substr($command[2], 0, 1) == '/' )		// $command[0] is the player id, 0 = server
			{
			return;
			}

		foreach ($this->textmsgs as $key => $value)
			{
			if ( !(stripos($command[2], $key) === false) )
				{
				if ( count($value) == 1 )
					{
					$message = $this->BotTag . $value[1];
					}
				else
					{
					$key = array_rand($value);
					$message = $this->BotTag . $value[$key];
					}
				$this->Aseco->client->query("ChatSendServerMessage", $message);
				return;
				}
			}

		foreach ($this->kickwords as $value)
			{
			if ( !(stripos($command[2], $value) === false) )
				{
				$message = $this->BotTag . $this->kicktext;
				$this->Aseco->client->query("ChatSendServerMessageToLogin", $message, $command[1]);
				$this->Aseco->client->query("Kick", $command[1]);
				return;
				}
			}

		foreach ($this->banwords as $value)
			{
			if ( !(stripos($command[2], $value) === false) )
				{
				$message = $this->BotTag . $this->bantext;
				$this->Aseco->client->query("ChatSendServerMessageToLogin", $message, $command[1]);
				$this->Aseco->client->query("Ban", $command[1]);
				return;
				}
			}

		foreach ($this->blacklistwords as $value)
			{
			if ( !(stripos($command[2], $value) === false) )
				{
				$message = $this->BotTag . $this->blacklisttext;
				$this->Aseco->client->query("ChatSendServerMessageToLogin", $message, $command[1]);
				$this->Aseco->client->query("BlackList", $command[1]);
				return;
				}
			}
		}  //  checkChatText

	}


$_PLUGIN = new ChatBot();
$_PLUGIN->setAuthor('Assembler Maniac');
$_PLUGIN->setVersion(1.0);
$_PLUGIN->setDescription('Bot that responds to chat text');
$_PLUGIN->addChatCommand('admin chatbotrestart', 'loadSettings', 'Reload chatbot with current settings from chatbot.xml');
$_PLUGIN->addEvent('onChat', 'checkChatText');
$_PLUGIN->addEvent('onStartup', 'loadSettings');
?>
