<?php
/*
 Display in blue/red (like the real checkpoints) what your last time was in relation to cp time of highest recorded run
 */

// move times to upper left, below the player count, set background transparency to same as player count

class RaspCPTimes extends Plugin
	{
	private $cp_times;			// array of checkpoint times
	private $record_time;			// best time on current track, unset if no time
	private $enabled;				// set on/off at begin of each race based on race mode
	private $challenge_uid;			// set on new track for faster reference later

	function startup()
		{
		// test for existence of BestCheckPoints col in challenges, add if not there
		$res = mysql_query('show create table challenges');
		$row = mysql_fetch_row($res);
		if ( stripos($row[1], 'BestCheckPoints') == 0)
			{
			mysql_query('alter table challenges add BestCheckPoints text');
			}
		mysql_free_result($res);
		}  //  startup

	function makeContent($t, $color = 'EEE')
		{
		// maybe someday this'll work
		// action='{name:cp_off,param:0}'
		$content = "<quad  sizen='14.4 3' posn='-1.2 .8' halign='left' valign='top' style='Bgs1InRace' substyle='BgTitle2' action='{name:cp_off,param:0}'/>
  					<label textsize='2' textcolor='EEE' posn='.7 .3' text='CP:' />
  					<label textsize='2' textcolor='" . $color . "' posn='4.1 .3' text=' " . $t . "' />";
		return $content;
		}  //  makeContent

	function onNewTrack(&$track)
		{
		// if stunts mode, hide w_cptime for all player, otherwise reset contents until something is needed to show
		$mode = $this->Aseco->server->gameinfo->getMode();
		$content = $this->makeContent('-0:00.00');
//		$content = "<quad  sizen='15 3' posn='-1.2 .8' halign='left' valign='top' style='Bgs1InRace' substyle='BgTitle2' action='{name:cp_off,param:0}/>
//  					<label textsize='2' textcolor='EEE' posn='.7 .3' text='CP:'/>
//  					<label textsize='2' textcolor='EEE' posn='4.1 .3' text=' -0:00.00'/>";
//		$content = "<line height='.02'><cell width='.05'><text action='{name:cp_off,param:0}' textcolor='EEE' halign='right'>CP:</text></cell>
//					<cell width='.13'><text textcolor='EEE' action='{name:cp_off,param:0}'> -0:00.00</text></cell></line>";
		foreach($this->Aseco->server->players->player_list as $player)
			{
			if ( !isset($player->data['w_cptime']) )
				{
				continue;
				}
			if ( $mode == 'Stunts' )
				{
				$player->data['w_cptime']->hide();
				}
			else
				{
				$player->data['w_cptime']->setContent($content);
				if ( !isset($player->data['hidecptime']) && $player->spectatorstatus == 0 )
					{
					$player->data['w_cptime']->show();
					}
				}
			}

		if ( $mode == 'Stunts' )
			{
			$this->enabled = 0;
			return;
			}

		$this->challenge_uid = $track->uid;
		$this->enabled = 1;

		$query = 'select bestcheckpoints from challenges where uid=' . quotedstring($this->challenge_uid) . ' and bestcheckpoints is not null';
		$result = mysql_query($query);		// returns one row, one col
		if ( mysql_num_rows($result) > 0 )
			{
			$row = mysql_fetch_row($result);
			$this->cp_times = explode(',', $row[0]);
			foreach($this->cp_times as $key => $value)		// even though $value isn't used, we still need the keys
				{
				settype($this->cp_times[$key], 'integer');
				}
			}
		else
			{
			$this->cp_times = array();
			}

		if ( isset($this->Aseco->plugins['PubDb']) )
			{
			$row = $this->Aseco->plugins['PubDb']->getCPTimes($this->challenge_uid);
			if ( $row[0] == 1 && strlen($row[1]) > 0 )
				{
				$t = explode(',', $row[1]);
				foreach($t as $key => $value)				// even though $value isn't used, we still need the keys
					{
					settype($t[$key], 'integer');
					}

				if ( count($this->cp_times) == 0 )
					{
					$this->cp_times = $t;
					}
				else
					if ($t[count($t)-1] < $this->cp_times[count($this->cp_times)-1] )
						{
						$this->cp_times = $t;
						}
				}
			}

		mysql_free_result($result);
		}  //  newTrack

	function onFinish(&$finish_item)
		{
		if ( $this->enabled == 0 || $finish_item->score == 0 ) return;
		if ( $this->Aseco->server->gameinfo->getMode() == 'Stunts' ) return;
		$player = $this->Aseco->server->players->getPlayer($finish_item->player->login);
		if ( $finish_item->score < $this->record_time ||
			 count($this->cp_times) == 0 ||
			 $finish_item->score < $this->cp_times[count($this->cp_times)-1])		// new time is better than what's saved, nothing is currently saved, or it's better than record
			{
			$this->record_time = $finish_item->score;
			$this->cp_times = $player->data['checkpoints'];
			$cpdata = implode(',', $this->cp_times);
			// write $cpdata to db here
			$query = 'update challenges set bestcheckpoints=\'' . $cpdata . '\' where uid=' . quotedstring($this->challenge_uid);
			mysql_query($query);
			if (mysql_affected_rows() != 1)
				{
				$errmsg = 'Failed to update bestcheckpoints: cp=' . $cpdata . ', uid=' . quotedstring($this->challenge_uid);
				$this->Aseco->console_text($errmsg);
				}
			}
		$player->data['checkpoints'] = array();
		}

	function onCheckpoint(&$cpdata)
		{
		if ( $this->enabled == 0 ) return;
//print_r($cpdata);
//print_r($this->cp_times);
		$player = $this->Aseco->server->players->getPlayer($cpdata[1]);
		$time = $cpdata[2];
		$cp = $cpdata[4];

//echo "player=".$cpdata[1].", cp=$cp, time=$time, ";
		if ( $cp == 0 )
			{
			$player->data['checkpoints'] = array();
			}
		$player->data['checkpoints'][$cp] = $time;
		if ( count($this->cp_times) > 0 )
			{
//echo "prevtime=".$this->cp_times[$cp].CRLF;
			$diff = $time - $this->cp_times[$cp];
			if ( $diff <= 0 )
				{
				$indicator = '-';
				$color = '00F';
				$diff = abs($diff);
				}
			else
				{
				$indicator = '+';
				$color = 'F00';
				}
			$diff = formatTime($diff);
			}
		else
			{
			$color = 'FFF';
			$indicator = '';
			$diff = formatTime($time);
			}

		//$content = '<line><cell><text>' . $color . 'CP: ' . $diff . $indicator . '</text></cell></line>';
		if ( substr($diff, 0, 2) == '00' )
			{
			$diff = substr($diff, 1);
			}
		$content = $this->makeContent($indicator . $diff, $color);

//		$content = "<quad  sizen='15 3' posn='-1.2 .8' halign='left' valign='top' style='Bgs1InRace' substyle='BgTitle2'/>
//  					<label textsize='2' textcolor='EEE' posn='.7 .3' text='CP:'/>
//  					<label textsize='2' textcolor='$color' posn='4.1 .3' text='" . $indicator . $diff . "'/>";
//					<line height='.02'><cell width='.05'><text action='{name:cp_off,param:0}' textcolor='EEE' halign='right'>CP:</text></cell>
//					<cell width='.13'><text action='{name:cp_off,param:0}' textcolor='$color'> " . $indicator . $diff . '</text></cell></line>';
		if (isset($player->data['w_cptime'])) $player->data['w_cptime']->setContent($content);
		}  //  checkpoint

	function onPlayerJoin(&$player)
		{
    	$window = $this->createWindowToPlayerFramework('', .09, -0.61, $player, true);
//		$window->makeStatic();
//		$content = "<line height='.02'><cell width='.05'><text action='{name:cp_off,param:0}' textcolor='EEE' halign='right'>CP:</text></cell>
//					<cell width='.13'><text action='{name:cp_off,param:0}' textcolor='EEE'>  0:00.00</text></cell></line>";
//		$content = "<quad  sizen='15 3' posn='-1.2 .8' halign='left' valign='top' style='Bgs1InRace' substyle='BgTitle2'/>
//  					<label textsize='2' textcolor='EEE' posn='.7 .3' text='CP:'/>
//  					<label textsize='2' textcolor='EEE' posn='4.1 .3' text=' -0:00.00'/>";
		$content = $this->makeContent('-0:00.00');

		$window->setContent($content);
		$window->setBackground('000F');
		$window->setTextsize(2);
		$window->addCallback('cp_off', 'cp_off');

		if ( $this->enabled == 1 && $player->spectatorstatus == 0)
			$window->show();
		else
			$window->hide();
		$player->data['w_cptime'] = $window;
		}

	function onEndRace(&$challenge)
		{
		if ( $this->enabled == 0 ) return;

		foreach($this->Aseco->server->players->player_list as $pl)
			{
			$pl->data['w_cptime']->hide();
			}

		// if pubdb is in use, submit best times from this race
		if ( isset($this->Aseco->plugins['PubDb']) && count($this->cp_times) > 0 )
			{
			$cpdata = implode(',', $this->cp_times);
			$row = $this->Aseco->plugins['PubDb']->putCPTimes($this->challenge_uid, $cpdata);
			}
		}

	function cp_off($clickvalue, &$window, &$player)
		{
		$player->data['hidecptime'] = true;
		$window->hide();
		$msg = 'To display checkpoint times, use /cptimes';
		$this->Aseco->client->query('ChatSendServerMessageToLogin', $msg, $player->login);
		}  //  cp_off

	function player_info_change(&$data)
		{
		$player = $data['player'];
		if ( isset($data['changedSpectator']) )
			{
			if ( !isset($player->data['w_cptime']) )
				{
				return;		// nothing to do, there's no window created
				}
			$window = $player->data['w_cptime'];
			if ( $player->spectatorstatus )			// player now spectating, hide the times
				{
				$window->hide();
				}
			else								// player is now playing, did they have cptimes hidden?
				if ( !isset($player->data['hidecptime']) )
					{
					$window->show();			// cptimes wasn't hidden, so show it
					}
			}
		}  //  cp_off

	function showcptimes(&$command)
		{
		if ( $this->enabled == 0 ) return;
		$player = $command['author'];
		if ( $player->spectatorstatus != 0 ) return;
		$window = $player->data['w_cptime'];
		$window->show();
		unset($player->data['hidecptime']);
		}  //  showcptime

	function onStatus4()
		{
		// if stunts mode, hide w_cptime for all player, otherwise reset contents until something is needed to show
		$mode = $this->Aseco->server->gameinfo->getMode();
//		$content = "<line height='.02'><cell width='.05'><text action='{name:cp_off,param:0}' textcolor='EEE' halign='right'>CP:</text></cell>
//					<cell width='.13'><text textcolor='EEE' action='{name:cp_off,param:0}'> -0:00.00</text></cell></line>";
//		$content = "<quad  sizen='15 3' posn='-1.2 .8' halign='left' valign='top' style='Bgs1InRace' substyle='BgTitle2'/>
//  					<label textsize='2' textcolor='EEE' posn='.7 .3' text='CP:'/>
//  					<label textsize='2' textcolor='EEE' posn='4.1 .3' text=' -0:00.00'/>";
		$content = $this->makeContent('-0:00.00');
		foreach($this->Aseco->server->players->player_list as $player)
			{
			if ( !isset($player->data['w_cptime']) )
				{
				continue;
				}
			if ( $mode == 'Stunts' )
				{
				$player->data['w_cptime']->hide();
				}
			else
				{
				$player->data['w_cptime']->setContent($content);
				if ( !isset($player->data['hidecptime']) && $player->spectatorstatus == 0)
					{
					$player->data['w_cptime']->show();
					}
				}
			}
		}  //  onStatus4
	}

$_PLUGIN = new RaspCPTimes();
$_PLUGIN->setAuthor('Assembler Maniac');
$_PLUGIN->setVersion(1.0);
$_PLUGIN->addDependence('LocalDb', 1.0, null);
$_PLUGIN->addEvent('onStartup', 'startup');
$_PLUGIN->addEvent('onPlayerFinish', 'onFinish');
$_PLUGIN->addEvent('onNewChallenge', 'onNewtrack');
$_PLUGIN->addEvent('onPlayerConnect', 'onPlayerJoin');
$_PLUGIN->addEvent('onCheckpoint', 'onCheckpoint');
$_PLUGIN->addEvent('onEndRace', 'onEndRace');
$_PLUGIN->addEvent('onStatusChangeTo4', 'onStatus4');
$_PLUGIN->addEvent('onPlayerInfoChanged', 'player_info_change');
$_PLUGIN->addChatCommand('cptimes', 'showcptimes', 'Shows checkpoint times');
?>
