<?php
/**
 * Chat plugin.
 * Vote for a track and display current score of it.
 */

class RaspKarma extends Plugin
	{
	private $enable_vote_popup = 0;
	private $show_vote_to_public = 0;
	private $enabled = false;

	function loadSettings()
		{
		$settings = $this->Aseco->xml_parser->parseXML('settings/rasp.xml');
		$settings = $settings['SETTINGS']['KARMA'][0];

		$this->enable_vote_popup = $settings['ENABLE_VOTE_POPUP'][0] == '1' ? 1 : 0;
		$this->show_vote_to_public = $settings['SHOW_VOTE_TO_PUBLIC'][0] == '1' ? 1 : 0;
		$this->messages = $settings['MESSAGES'][0];

		foreach ($this->messages as $key => $value)
			{
			unset($this->messages[$key]);
			$this->messages[$key] = $value[0];
			}

		$query = 'CREATE TABLE IF NOT EXISTS `rs_karma` (
								`Id` int(11) NOT NULL auto_increment,
								`Score` smallint(6) NOT NULL default 0,
								`PlayerId` mediumint(9) NOT NULL default 0,
								`ChallengeId` mediumint(9) NOT NULL default 0,
								PRIMARY KEY	(`Id`),
								UNIQUE KEY `PlayerId` (`PlayerId`,`ChallengeId`),
								KEY `ChallengeId` (`ChallengeId`)
							) TYPE=MyISAM Default Character Set UTF8';
		mysql_query($query);

		$res = mysql_query('show tables');
		while ($row = mysql_fetch_row($res)){ $tables[] = $row[0]; }

		if (in_array('rs_karma', $tables)) { $this->enabled = true; }
		mysql_free_result($res);

		$res = mysql_query('show columns from challenges');
		while ($row = mysql_fetch_row($res)){ $cols[] = $row[0]; }
		mysql_free_result($res);

		if (!in_array('GoodKarma', $cols))
			{
			$query = 'alter table challenges add GoodKarma mediumint null default 0, add BadKarma mediumint null default 0';
			mysql_query($query);

			$res = mysql_query('show columns from challenges');
			while ($row = mysql_fetch_row($res)){ $cols[] = $row[0]; }
			mysql_free_result($res);

			if (in_array('GoodKarma', $cols))
				{
				$this->karmaCalc();
				$this->enabled = true;
				$this->Aseco->console_text('[RASP Karma] Challenges alteration complete');
				}
			else
				{
				$this->Aseco->console_text('[RASP Karma] Failed to alter challenges to add karma values');
				}

			}
		else
			{
			if ( $settings['RECALC'][0] == '1' )
				{
				$this->karmaCalc();
				}
			}


		}  //  loadSettings

	function karmaCalc()
		{
		$this->Aseco->console_text('[RASP Karma] Re-calculating good karma');
		$query = 'update challenges set goodkarma = (select sum(score) from rs_karma where rs_karma.challengeid=challenges.id and rs_karma.score > 0)';
		mysql_query($query);
		$this->Aseco->console_text('[RASP Karma] Re-calculating bad karma');
		$query = 'update challenges set badkarma = (select sum(score) from rs_karma where rs_karma.challengeid=challenges.id and rs_karma.score < 0)';
		mysql_query($query);
		$this->Aseco->console_text('[RASP Karma] Zeroing out null good karma');
		$query = 'update challenges set goodkarma = 0 where goodkarma is null';
		mysql_query($query);
		$this->Aseco->console_text('[RASP Karma] Zeroing out bad karma');
		$query = 'update challenges set badkarma = 0 where badkarma is null';
		mysql_query($query);
		}  //  karmaCalc

	function check4KarmaChatText(&$command)
		{
		if ( $this->enabled == false )
			{
			return;
			}

		if ($command[2] == '++')
			{
			$command['author'] = $this->Aseco->server->players->getPlayer($command[1]);
			$this->KarmaVote($command, 1);
			}
		elseif ( $command[2] == '--' )
			{
			$command['author'] = $this->Aseco->server->players->getPlayer($command[1]);
			$this->KarmaVote($command, -1);
			}
		}

	function KarmaVote(&$command, $vote)
		{
		$login_id = $command['author']->login;
		$this->Aseco->console_text('Registering vote....');
		$query = 'SELECT Id FROM players WHERE Login=' . quotedString($login_id);
		$res = mysql_query($query);
		if (mysql_num_rows($res) > 0)
			{
			$row = mysql_fetch_row($res);
			$pid = $row[0];
			}
		else
			{
			$this->Aseco->console_text('no player!');
		 	return;
			}
		mysql_free_result($res);

		$query2 = 'SELECT Id, Score FROM rs_karma WHERE PlayerId=' . $pid . ' AND ChallengeId=' . $this->Aseco->server->challenge->data['DB_ID'];
		$res2 = mysql_query($query2);
		if (mysql_num_rows($res2) > 0)
			{
			$row = mysql_fetch_object($res2);
			if ($row->Score == $vote)
				{
				$message = $this->Aseco->formatColors($this->messages['VOTED_ALREADY']);
				$this->Aseco->client->query('ChatSendServerMessageToLogin', $message, $login_id);
				}
			else
				{
				$query3 = 'UPDATE rs_karma SET Score=' . $vote . ' WHERE Id=' . $row->Id;
				mysql_query($query3);
				if (mysql_affected_rows() < 1)
					{
					$msg = $this->Aseco->formatColors($this->messages['VOTE_FAILED']);
					$this->Aseco->client->query('ChatSendServerMessageToLogin', $msg, $login_id);
					}
				else
					{
					$query3 = 'Update Challenges set GoodKarma=GoodKarma+(' . $vote . '), BadKarma=BadKarma+(' . $vote . ') where Id=' . $this->Aseco->server->challenge->data['DB_ID'];
					mysql_query($query3);
					$msg = $this->Aseco->formatColors($this->messages['VOTE_OK']);
					$this->Aseco->client->query('ChatSendServerMessageToLogin', $msg, $login_id);
					$this->Aseco->releaseEvent('onKarmaChange', $this->getKarmaValues($this->Aseco->server->challenge));
					$this->chat_karma($command);
					}
				}
			}
		else
			{
			$query3 = 'INSERT INTO rs_karma (Score, PlayerId, ChallengeId) VALUES (' . $vote . ', ' . $pid . ', ' . $this->Aseco->server->challenge->data['DB_ID'] . ')';
			mysql_query($query3);
			if (mysql_affected_rows() < 1)
				{
				$msg = $this->Aseco->formatColors($this->messages['VOTE_FAILED']);
				$this->Aseco->client->query('ChatSendServerMessageToLogin', $msg, $login_id);
				}
			else
				{
				if ( $vote > 0 )
					{
					$query3 = 'Update challenges set GoodKarma=GoodKarma+1 where id=' . $this->Aseco->server->challenge->data['DB_ID'];
					}
				else
					{
					$query3 = 'Update challenges set BadKarma=BadKarma-1 where id=' . $this->Aseco->server->challenge->data['DB_ID'];
					}
				mysql_query($query3);
				$msg = $this->Aseco->formatColors('{#highlite} Vote Successful!');
				$this->Aseco->client->query('ChatSendServerMessageToLogin', $msg, $login_id);
				$this->Aseco->releaseEvent('onKarmaChange', $this->getKarmaValues($this->Aseco->server->challenge));
				$this->chat_karma($command);
				}
			}
		mysql_free_result($res2);
		}

	function displayKarmaVote($votestring, &$command)
		{
		if ( $this->show_vote_to_public == 0 )
			{
			return;
			}
		$nick = $command['author']->nickname;
		if ( $votestring == '++' )
			{
			$karma = $this->messages['KARMA_GOOD'];
			}
		else
			{
			$karma = $this->messages['KARMA_BAD'];
			}
		$message = formatText($this->messages['KARMA_SHOW_TEXT'], $nick, $karma, $votestring);
		$message = $this->Aseco->formatColors($message);
		$this->Aseco->client->query('ChatSendServerMessage', $message);
		}  //  displayKarmaVote

	function chat_plusplus(&$command)
		{
		if ( $this->enabled == false )
			{
			return;
			}
		$this->KarmaVote($command, 1);
		$this->displayKarmaVote('++', $command);
		}  //  chat_plusplus

	function chat_dashdash(&$command)
		{
		if ( $this->enabled == false )
			{
			return;
			}
		$this->KarmaVote($command, -1);
		$this->displayKarmaVote('--', $command);
		}  //  chat_plusplus

	function newTrack(&$challenge)
		{
		if ( $this->enabled == false )
			{
			return;
			}
		if ( !isset($challenge->data['DB_ID']) )
			{
			$challenge->data['DB_ID'] = $this->getChallengeId($challenge->uid);
			}
		$message = $this->getKarma($challenge);

		// send the message ...
		$this->Aseco->client->query('ChatSendServerMessage', $message);

		$this->onStatus4($challenge);
		}

	function onStatus4(&$info)
		{
		if ( $this->enable_vote_popup )
			{
			foreach($this->Aseco->server->players->player_list as $player)
				{
				$window = $player->data['w_karma'];
				if ( isset($window) )
					{
					$window->close();
					unset($player->data['w_karma']);
					}
				}
			}
		}  //  onRaceBegin

	function chat_karma(&$command)
		{
		if ( $this->enabled == false )
			{
			return;
			}
		$message = $this->getKarma($this->Aseco->server->challenge);

		// send the message ...
		$this->Aseco->client->query('ChatSendServerMessageToLogin', $message, $command['author']->login);
		}

	function getKarmaValues(&$challenge)
		{
		$query = 'Select goodkarma, badkarma from challenges WHERE Id=' . $challenge->data['DB_ID'];
		$res = mysql_query($query);
		if ( mysql_num_rows($res) == 1 )
			{
			$row = mysql_fetch_row($res);
			$goodkarma = $row[0];
			$badkarma = abs($row[1]);
			}
		else
			{
			$goodkarma = 0;
			$badkarma = 0;
			}
		mysql_free_result($res);

		if ( !isset($goodkarma) )
			{
			$goodkarma = 0;
			}

		if ( !isset($badkarma) )
			{
			$badkarma = 0;
			}

		$totkarma = $badkarma + $goodkarma;

		if ( $goodkarma > 0 )
			{
			$div1 = $totkarma / $goodkarma;
			if ( $div1 > 0 )
				{
				$div1 = (100 / $div1);
				}
			}
		else
			$div1 = 0.00;

		$div1 = number_format($div1, 2);

		return array('TotalVotes'=>$totkarma, 'Good'=>$goodkarma, 'Bad'=>$badkarma, 'GoodPct'=>$div1);
		}  //  getKarmaValues

	function getKarma(&$challenge)
		{
		$karma = $this->getKarmaValues($challenge);
		// replace parameters ...
		$message = formatText($this->messages['KARMA_DISPLAY'], $karma['TotalVotes'], $karma['Good'], $karma['Bad'], $karma['GoodPct']);

		// replace colors ...
		$message = $this->Aseco->formatColors($message);

		return $message;
		}

	function onEndRace(&$challenge)		// $challenge[0] = player info from server, [1] = challenge info from server, neither is object maintained by aseco
		{
		if ( !$this->enable_vote_popup || !$this->enabled )
			{
			return;
			}

		foreach($this->Aseco->server->players->player_list as $player)
			{
			$query = 'SELECT Id FROM players WHERE Login=' . quotedString($player->login);
			$res = mysql_query($query);
			if (mysql_num_rows($res) > 0)
				{
				$row = mysql_fetch_row($res);
				$pid = $row[0];
				}
			else
				{
				$this->Aseco->console_text('no player!');
			 	return;
				}
			mysql_free_result($res);

			$popwin = true;
			$query2 = 'SELECT Id, Score FROM rs_karma WHERE PlayerId=' . $pid . ' AND ChallengeId=' . $this->Aseco->server->challenge->data['DB_ID'];
			$res2 = mysql_query($query2);
			if (mysql_num_rows($res2) > 0)
				{
				$popwin = false;
				}
			mysql_free_result($res2);

			if ( $popwin )
				{
    			$window = $this->createWindowToPlayerFramework('', .9, -.39, $player, true);
//				$window->makeStatic();
				// Karma Vote
				// Track Name (without colors)
				// Good / Bad (green/red)
				// Later

				$content = "<line><cell><text textcolor='ee0'>How did you like \$i'" . htmlspecialchars(stripFormatting($challenge[1]['Name'])). "'\$i ?</text></cell>";
				$content .= "<cell><text textcolor='0e0' halign='center' action='{name:karmavote,param:1}'> Good</text></cell>
							<cell><text textcolor='e00' halign='center' action='{name:karmavote,param:3}'> Bad</text></cell>
							<cell><text textcolor='333' halign='center' action='{name:karmavote,param:2}'> Undecided</text></cell></line>";
				$window->setContent($content);
				$window->setBackground('999F');
				$window->setTextsize(2);
				$window->addCallback('karmavote', 'karmaVoteClick');
				$window->show();
				$player->data['w_karma'] = $window;
				}
			}

		// run loop of players, find out who needs to vote, send them popup window if config calls for it
		}  //  onEndRace

	function karmaVoteClick($clickvalue, &$window, &$player)
		{
		// $clickvalue 1 = Good, 2 = later, 3 = Bad
		$window->close();
		unset($player->data['w_karma']);
		if ( $clickvalue == 2 )
			{
			return;
			}
		elseif ( $clickvalue == 1 )
			{
			$command['author'] = $player;
			$this->KarmaVote($command, 1);
			}
		elseif ( $clickvalue == 3 )
			{
			$command['author'] = $player;
			$this->KarmaVote($command, -1);
			}
		}  //  karmaClickVote

	function getChallengeId($uid)
		{
		$query = 'SELECT Id FROM challenges WHERE Uid=\'' . mysql_real_escape_string($uid) . '\'';
		$res = mysql_query($query);
		if (mysql_num_rows($res) > 0)
			{
			$row = mysql_fetch_row($res);
			$rtnval = $row[0];
			}
		else
			{
			$rtnval = 0;
			}
		mysql_free_result($res);
		return $rtnval;
		}
	}

$_PLUGIN = new RaspKarma();
$_PLUGIN->setAuthor('Assembler Maniac');
$_PLUGIN->setVersion(1.0);
$_PLUGIN->addDependence('LocalDb', 1.0, null);
$_PLUGIN->setDescription('Vote +/- on a track');
$_PLUGIN->addChatCommand('karma', 'chat_karma', 'displays karma for the current track');
$_PLUGIN->addChatCommand('++', 'chat_plusplus', 'increases karma for the current track');
$_PLUGIN->addChatCommand('--', 'chat_dashdash', 'decreases karma for the current track');
$_PLUGIN->addEvent('onEndRace', 'onEndRace');
$_PLUGIN->addEvent('onChat', 'check4KarmaChatText');
$_PLUGIN->addEvent('onNewChallenge', 'newTrack');
$_PLUGIN->addEvent('onStartup', 'loadSettings');
$_PLUGIN->addEvent('onStatusChangeTo4', 'onStatus4');
?>
