<?php
/**
 * Can store challenge information.
 * You can instanciate with an rpc "GetChallengeInfo" response.
 */
class Challenge {
  var $name;
  var $uid;
  var $filename;
  var $author;
  var $environment;
  var $mood;
  var $bronzetime;
  var $silvertime;
  var $goldtime;
  var $authortime;
  var $copperprice;
  var $laprace;
  var $data; // can be used to store additional information
  
  // instanciates the class with and rpc response ...
  function Challenge($rpc_infos = null) {
    if ($rpc_infos) {
      
      // import the xml rpc response of a challenge ...
      $this->id = 0;
      $this->name = $rpc_infos['Name'];
      $this->uid = $rpc_infos['UId'];
      $this->filename = $rpc_infos['FileName'];
      $this->author = $rpc_infos['Author'];
      $this->environment = $rpc_infos['Environnement'];
      $this->mood = $rpc_infos['Mood'];
      $this->bronzetime = $rpc_infos['BronzeTime'];
      $this->silvertime = $rpc_infos['SilverTime'];
      $this->goldtime = $rpc_infos['GoldTime'];
      $this->authortime = $rpc_infos['AuthorTime'];
    } else {
      
      // set defaults ...
      $this->id = 0;
      $this->name = "none";
    }
  }
}
?>