<?php
/**
 * Manages players on the server.
 * Add player and remove them.
 */
class PlayerList {
  var $player_list;
  
  function PlayerList() {
    $this->player_list = array();
  }
  
  function nextPlayer() {
    if (is_array($this->player_list)) {
      $player_item = current($this->player_list);
      next($this->player_list);
      return $player_item;
    } else {
      $this->resetPlayers();
      return false;
    }
  }
  
  function resetPlayers() {
    if (is_array($this->player_list)) {
      reset($this->player_list);
    }
  }
  
  function addPlayer($player) {
    if (get_class($player) == 'Player') {
      $this->player_list[$player->login] = $player;
      return true;
    } else {
      return false;
    }
  }
  
  function removePlayer($login) {
    if (isset($this->player_list[$login])) {
      $this->player_list[$login]->dispose();
      unset($this->player_list[$login]);
    }
  }
  
  function getPlayer($login) {
    return $this->player_list[$login];
  }
  
  function resetVotings() {
    if (!empty($this->player_list)) {
      foreach ($this->player_list as $player) {
        $player->hasvoted = false; 
      }
    }
  }
}
?>